<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- produces a .wpo with the (empty) TRANSLATE tags for the tags that need translation -->
<!-- NOTE: It should try to make a merge if the translation file exists already -->

<!-- example of use: xsl-c -XSL prepare_translation.xsl -IN ../examples/dns.naat (prints on the standard output)-->

<xsl:param name="wpofile"/>

<xsl:output method="xml" encoding="iso-8859-1" indent="yes"/>

<xsl:template match="/">
<![CDATA[
<!DOCTYPE Wizard SYSTEM "../../modules/dtd/Naat.dtd"[
<!ENTITY % definition SYSTEM "../../modules/dtd/definition.ent">
%definition;
]>
]]>
<xsl:copy>
<xsl:apply-templates select="*|@*"/>
</xsl:copy>
</xsl:template>

<xsl:template match="@*|node()|comment()">
	<xsl:copy>
	<xsl:apply-templates select="@*|node()"/>
	</xsl:copy>
</xsl:template>

<xsl:template match="TRANSLATE">
 <xsl:if test="from[node()]">
	<xsl:copy>
		<xsl:apply-templates select="@*|from"/>
		<to>
		<xsl:call-template name="routine">
		<xsl:with-param name="fromtext">
		<xsl:value-of select="from"/>
		</xsl:with-param>
		</xsl:call-template>
		</to>
	</xsl:copy>
 </xsl:if>
</xsl:template>

<xsl:template match="from">
	<xsl:copy-of select="."/>
</xsl:template>

<!-- the actual translation routine  -->
<xsl:template name="routine">
  <xsl:param name="fromtext"/>
  <xsl:choose>
<!-- if a translation exists for the given fromtext, insert the translation... -->
<!--(this test accesses the translation file twice: can we do better?) -->
    <xsl:when test="document($wpofile)//*/from[text()=$fromtext]/../to and string-length(document($wpofile)//*/from[text()=$fromtext]/../to)>0">
      <xsl:value-of select="document($wpofile)//*/from[text()=$fromtext]/../to"/>
    </xsl:when>
<!-- otherwise leave the english version -->
    <xsl:otherwise>
	<!--<xsl:value-of select="$fromtext"/>-->
	<xsl:value-of select="''"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="text()"/>

</xsl:stylesheet>
