<!DOCTYPE xsl:stylesheet [
<!ENTITY % imageEntity SYSTEM "../modules/dtd/image.ent">
%imageEntity;
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- xsl for php functions -->
<xsl:import href="php_func.xsl"/>
<xsl:import href="include.xsl"/>
<!--<xsl:import href="help_page.xsl"/> -->

<xsl:output method="html" indent="yes" omit-xml-declaration="yes" encoding="iso-8859-1"/>

<xsl:strip-space elements="Wizard"/>
<!-- The 'page' parameter is passed from outside and contains the name of the page to generate -->
<xsl:param name="page"/>

<!-- the 'type' parameter determines the type of wizard ('wizard' or 'day-to-day') -->
<xsl:param name="type"/>

<!-- the 'helpURL' parameter determines the help location for this page -->
<xsl:param name="helpURL"/>

<!-- The 'helppage' parameter is passed from outside and contains -->
<!-- the name of the Help Page to generate -->
<xsl:param name="helppage"/>

<!-- the source program name (.wvm) is used in the HTML of this page to redirect the POST actions --> 
<xsl:param name="src"/>
<!-- root-path used to define main directory containing pages -->
<xsl:param name="root-path"/>

<!-- the codebase parameter allows to specify the applets directory --> 
<xsl:param name="codebase"/>

<xsl:param name="tableborders">0</xsl:param>

<xsl:param name="lang"/>

<!-- The main template. Outputs the common part, then calls apply-templates on Decoration, then the apply-templates -->
<xsl:template match="Wizard">
<xsl:if test="string-length($helppage)=0">

	<xsl:processing-instruction name="php">
/*
 Network Appliance Administration Tool

	 Copyright (C) 2002 MandrakeSoft SA

	 This program may be distributed and/or
	 modified under the terms of the GNU General Public
	 License version 2 as published by the Free Software Foundation

	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	 General Public License for more details.

	 Licensees holding valid MandrakeSecurity MNF Commercial License may use this file in  accordance with the MandrakeSecurity MNF Commercial License Agreement provided with the Software.

	 See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
*/
// include relative to admin/
require_once (&quot;interpreter/php_libs/naatengine.inc.php&quot;);
?</xsl:processing-instruction>

	<xsl:comment> Start of Contents </xsl:comment> 
	<!-- ##### Main Content ##### -->
	<form method="post">
		<xsl:attribute name="action">engine.php?file=<xsl:value-of select="$root-path"/>/<xsl:value-of select="$src"/>/<xsl:value-of select="$src"/>.wvm</xsl:attribute>
	<xsl:attribute name="enctype">multipart/form-data</xsl:attribute>
              
	<xsl:apply-templates select="//Page[@name=$page]"/>

	<br/>

	<!-- Start Navigation Bar 
	(Help, Cancel, Previous, Next, Apply )
	-->
	<xsl:call-template name="generate_html_nav_wizard">
		<xsl:with-param name="type"><xsl:value-of select="$type"/></xsl:with-param>
		<xsl:with-param name="root-path"><xsl:value-of select="$root-path"/></xsl:with-param>
		<xsl:with-param name="helpURL"><xsl:value-of select="$helpURL"/></xsl:with-param>
		<xsl:with-param name="lang"><xsl:value-of select="$lang"/></xsl:with-param>
	</xsl:call-template>
	<!-- End of Navigation Bar -->

	</form>
  	<!-- ##### End of Main Content ##### -->

			<xsl:comment>
				End of Contents 
				generated by: <xsl:value-of select="system-property('xsl:vendor')"/>,
				URL :<xsl:value-of select="system-property('xsl:vendor-url')"/>,
				xsl version:<xsl:value-of select="system-property('xsl:version')"/>.
			</xsl:comment> 

</xsl:if>

<xsl:if test="string-length($helppage)>0">
		<xsl:apply-templates select="//Page[@name=$page]"/>
</xsl:if>

</xsl:template>
<!-- End of Wizard Template -->




<!-- Rules for the wizard page -->
<xsl:template match="//Page[@name=$page]">
	<xsl:if test="node()">
	<xsl:text>
</xsl:text>
	<xsl:comment>Start Page</xsl:comment>
	<xsl:text>
</xsl:text>

	<!-- TODO: analyze the page content to find 'variable' attributes. -->
	<!-- Then generate a php header that performs a single backend     -->
	<!-- request to get all variables values at once.                  -->
   	<xsl:comment> Variables used in this page </xsl:comment>
	<xsl:processing-instruction name="php">
	unset ($variables_list);

	// Simple quotes to prevent php from evaluating variables in the string
	$variables_list='<xsl:for-each select="descendant::Field|descendant::Checkbox|descendant::Boolean|descendant::List|descendant::Dyntable">
		<xsl:if test="@variable != ''">
			<xsl:value-of select="@variable"/>
			<xsl:if test="not(position()=last())">,</xsl:if>
		</xsl:if>
	</xsl:for-each>';

	generate_php_preload_variables($variables_list);
	?</xsl:processing-instruction>


	<xsl:apply-templates/>

   	<xsl:comment> End Page </xsl:comment>
				</xsl:if>
</xsl:template>

<!-- Rules for the Help Page
outide the naat file, done in help_page.xsl -->
  <xsl:template match="HelpPage"/>

<xsl:template match="text()"/>

</xsl:stylesheet>

<!-- $Id: naat.xsl,v 1.27 2002/12/03 14:50:19 philippe Exp $ -->
