<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" indent="yes" omit-xml-declaration="yes"/>

<!-- generate_php_get_list 
	generate a dynamic list from an action
	3 types:
	list, boolean, checkbox
	 -->
	
<xsl:template name="generate_php_get_list">
<xsl:param name="action_name"/>
<xsl:param name="variable_name"/>
<xsl:param name="type"/>
<xsl:processing-instruction name="php">
unset ($variable_name);
unset ($action_name);
unset ($input_type);
$variable_name=&quot;\<xsl:value-of select="$variable_name"/>&quot;;
$action_name=&quot;<xsl:value-of select="$action_name"/>&quot;;
$input_type=&quot;<xsl:value-of select="$type"/>&quot;;
generate_php_get_list($variable_name,$input_type,$action_name);
?</xsl:processing-instruction>
<!-- exec(&quot;<xsl:value-of select="$action_name"/>&quot; , &amp;$arraylist ,
&amp;$var);
$list = explode (",", $arraylist[0]);
for ($k=0; $k&lt;count($list); $k++) {
	<xsl:choose>
    <xsl:when test="$type='Boolean'">
		print "&lt;input
			type=\&quot;radio\&quot;
			name=\&quot;<xsl:value-of select="$variable_name"/>\&quot;
			value=\&quot;$list[$k]\&quot;/&gt;$list[$k] ";
		print "&lt;br&gt;";
	</xsl:when>
    <xsl:when test="$type='Checkbox'">
		print "&lt;input
			type=\&quot;checkbox\&quot;
			name=\&quot;<xsl:value-of select="$variable_name"/>[]\&quot;
			value=\&quot;$list[$k]\&quot;/&gt;$list[$k]";
		print "&lt;br&gt;";
	</xsl:when>
    <xsl:otherwise>
		print "&lt;option value=\&quot;$list[$k]\&quot;&gt;$list[$k]&lt;/option&gt;";
	</xsl:otherwise>
	</xsl:choose>
}
?</xsl:processing-instruction>
-->
</xsl:template>

<!-- This stylesheets generates the right php code to get the value of the
   	given variable from the backend 
    we use <xsl:processing-instruction> construction to build the 
	php tag 
		   sample output	:	
<?php unset ($AccessType); 
exec("config-wrapper.pl trans -g  AccessType" , &$AccessType, &$var);
print $AccessType[0];
?>
			  -->
<xsl:template name="generate_php_get_variable">
<xsl:param name="variable_name"/>
<xsl:param name="action_name"/>
<xsl:param name="type"/>
<xsl:param name="type_field"/>

<xsl:processing-instruction name="php">
unset ($variable_name);
unset ($action_name);
unset ($input_type);
unset ($field_type);
$variable_name=&quot;\<xsl:value-of select="$variable_name"/>&quot;;
$action_name=&quot;<xsl:value-of select="$action_name"/>&quot;;
$input_type=&quot;<xsl:value-of select="$type"/>&quot;;
$type_field=&quot;<xsl:value-of select="$type_field"/>&quot;;
generate_php_get_variable($variable_name,$input_type,$action_name,$type_field);
?</xsl:processing-instruction>

</xsl:template>
<!--  old version  to be deleted
$variable = &quot;\<xsl:value-of select="$variable_name"/>&quot;;
$list = explode("$", $variable);
 for ($i=0;$i&lt;sizeof($list); $i++) 
 {
   if (ereg(&quot;\{(.+)\}(.*)&quot;, $list[$i], &amp;$regs))
     {
        exec(&quot;config-wrapper.pl trans -g &quot; . $regs[1], &amp;$ret);
	$var .= $ret[0] . $regs[2];
     }	
   else	
     {
        $var .= $list[$i];
     }
 }
exec(&quot;config-wrapper.pl trans -g &quot; . $var, &amp;$result , &amp;$var);
print $result[0];
-->

<!-- Simple tempate to create four nbspaces. Please, add a parameter ! -->
  <xsl:template name="spaces">
  <xsl:text
  disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
    </xsl:template>

<xsl:template name="Label">
          <xsl:value-of select="."/>
</xsl:template>

<xsl:template name="Navigation"/>

</xsl:stylesheet>

<!-- $Id: php_func_orig.xsl,v 1.1.1.1 2001/06/13 11:38:15 rchaillat Exp $ -->

