<?xml version="1.0"?> 
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!-- A *very perverse* xsl program that produces a shell script 
  containing a call to xsl foreach page to generate
  3 format of file:
  day-to-day : help, apply, cancel
  start-wizard : help, next, cancel
  wizard : help, previous, next, cancel
  end-wizard : help, previous, apply, cancel
  -->

  <xsl:output method="text" indent="yes"/>
  <xsl:param name="file"/>
  <xsl:param name="xsl"/>
  <xsl:param name="directory"/>
  <xsl:param name="src"/>
  <xsl:param name="root-path"/>
  <xsl:param name="codebase"/>
  <xsl:param name="xsl-compiler"/>
  <xsl:param name="lang"/>


		<xsl:strip-space elements="*"/>

  <xsl:template match="/">
    <xsl:apply-templates />
  </xsl:template>
  
		<!-- temlate name definition -->
		<!-- generic template to process xml file and -->
		<!-- generate the corresponding php page -->
		<xsl:template name="generate_php_page">
			<xsl:param name="xsl-compiler"/>
			<xsl:param name="name"/>
			<xsl:param name="type"/>
			<xsl:param name="src"/>
			<xsl:param name="helpURL"/>
			<xsl:param name="codebase"/>
			<xsl:param name="xsl"/>
			<xsl:param name="file"/>
			<xsl:param name="directory"/>
			<xsl:param name="root-path"/>
			<xsl:param name="lang"/>
  <!-- Test the XSLT compiler we use -->
  <xsl:choose>
  <!-- libxslt case -->
  <xsl:when test="$xsl-compiler='xsltproc'">
		 <xsl:value-of select="$xsl-compiler"/><xsl:text> --param page "'</xsl:text>
			<xsl:value-of select="$name"/><xsl:text>'" --param lang "'</xsl:text>
			<xsl:value-of select="$lang"/><xsl:text>'" --param src "'</xsl:text>
			<xsl:value-of select="$src"/><xsl:text>'" --param type "'</xsl:text>
			<xsl:value-of select="$type"/><xsl:text>'" --param helpURL "'</xsl:text>
			<xsl:value-of select="$helpURL"/><xsl:text>'" --param codebase "'</xsl:text>
			<xsl:value-of select="$codebase"/><xsl:text>'" </xsl:text>
<xsl:text>--param root-path "'</xsl:text><xsl:value-of select="$root-path"/><xsl:text>'" </xsl:text>
			<xsl:value-of select="$xsl"/><xsl:text> </xsl:text>
			<xsl:value-of select="$file"/><xsl:text> > </xsl:text>
			<xsl:value-of select="$directory"/><xsl:text>/</xsl:text>
			<xsl:value-of select="$name"/><xsl:text>.php</xsl:text>
				</xsl:when>
  <!-- XALAN case -->
				<xsl:otherwise>
<xsl:value-of select="$xsl-compiler"/><xsl:text> </xsl:text>
<xsl:text>-IN </xsl:text><xsl:value-of select="$file"/>
<xsl:text>-XSL </xsl:text><xsl:value-of select="$xsl"/>
<xsl:text>-OUT </xsl:text><xsl:value-of select="$directory"/><xsl:text>/</xsl:text><xsl:value-of select="$name"/><xsl:text>.php </xsl:text>
<xsl:text>-PARAM page "'</xsl:text><xsl:value-of select="$name"/><xsl:text>'" </xsl:text>
<xsl:text>-PARAM src "'</xsl:text><xsl:value-of select="$src"/><xsl:text>'" </xsl:text>
<xsl:text>-PARAM type "'</xsl:text><xsl:value-of select="$type"/><xsl:text>'" </xsl:text>
<xsl:text>-PARAM helpURL "'</xsl:text><xsl:value-of select="$helpURL"/><xsl:text>'" </xsl:text>
<xsl:text>-PARAM codebase "'</xsl:text><xsl:value-of select="$codebase"/><xsl:text>'" </xsl:text>
<xsl:text>-PARAM root-path "'</xsl:text><xsl:value-of select="$root-path"/><xsl:text>'" </xsl:text>
			</xsl:otherwise>
			</xsl:choose>
<xsl:text>
</xsl:text> 
		</xsl:template>


  <!-- Process pages only once, i.e. only the definition (page node
  has contents) and not a simple reference to the page -->
  <!-- xsl:template match="Page[*]" -->

  <!-- Process each page only once, allowing empty pages -->
  <xsl:template match="Page">
  <xsl:if test="not(preceding::Page/@name=./@name)">

			<xsl:choose>
				<xsl:when test="@type">
					<xsl:call-template name="generate_php_page">
						<xsl:with-param name="xsl-compiler"><xsl:value-of select="$xsl-compiler"/></xsl:with-param>
						<xsl:with-param name="name"><xsl:value-of select="@name"/></xsl:with-param>
						<xsl:with-param name="type"><xsl:value-of select="@type"/></xsl:with-param>
						<xsl:with-param name="src"><xsl:value-of select="$src"/></xsl:with-param>
						<xsl:with-param name="helpURL"><xsl:value-of select="@helpURL"/></xsl:with-param>
						<xsl:with-param name="codebase"><xsl:value-of select="$codebase"/></xsl:with-param>
						<xsl:with-param name="xsl"><xsl:value-of select="$xsl"/></xsl:with-param>
						<xsl:with-param name="file"><xsl:value-of select="$file"/></xsl:with-param>
						<xsl:with-param name="directory"><xsl:value-of select="$directory"/></xsl:with-param>
						<xsl:with-param name="root-path"><xsl:value-of select="$root-path"/></xsl:with-param>
						<xsl:with-param name="lang"><xsl:value-of select="$lang"/></xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="count(//Page)=1">
					<xsl:call-template name="generate_php_page">
						<xsl:with-param name="xsl-compiler"><xsl:value-of select="$xsl-compiler"/></xsl:with-param>
						<xsl:with-param name="name"><xsl:value-of select="@name"/></xsl:with-param>
						<xsl:with-param name="type">apply</xsl:with-param>
						<xsl:with-param name="src"><xsl:value-of select="$src"/></xsl:with-param>
						<xsl:with-param name="helpURL"><xsl:value-of select="@helpURL"/></xsl:with-param>
						<xsl:with-param name="codebase"><xsl:value-of select="$codebase"/></xsl:with-param>
						<xsl:with-param name="xsl"><xsl:value-of select="$xsl"/></xsl:with-param>
						<xsl:with-param name="file"><xsl:value-of select="$file"/></xsl:with-param>
						<xsl:with-param name="directory"><xsl:value-of select="$directory"/></xsl:with-param>
						<xsl:with-param name="root-path"><xsl:value-of select="$root-path"/></xsl:with-param>
						<xsl:with-param name="lang"><xsl:value-of select="$lang"/></xsl:with-param>
					</xsl:call-template>
				</xsl:when>


				<xsl:otherwise>
					<xsl:call-template name="generate_php_page">
						<xsl:with-param name="xsl-compiler"><xsl:value-of select="$xsl-compiler"/></xsl:with-param>
						<xsl:with-param name="name"><xsl:value-of select="@name"/></xsl:with-param>
						<xsl:with-param name="type">wizard</xsl:with-param>
						<xsl:with-param name="src"><xsl:value-of select="$src"/></xsl:with-param>
						<xsl:with-param name="helpURL"><xsl:value-of select="@helpURL"/></xsl:with-param>
						<xsl:with-param name="codebase"><xsl:value-of select="$codebase"/></xsl:with-param>
						<xsl:with-param name="xsl"><xsl:value-of select="$xsl"/></xsl:with-param>
						<xsl:with-param name="file"><xsl:value-of select="$file"/></xsl:with-param>
						<xsl:with-param name="directory"><xsl:value-of select="$directory"/></xsl:with-param>
						<xsl:with-param name="root-path"><xsl:value-of select="$root-path"/></xsl:with-param>
						<xsl:with-param name="lang"><xsl:value-of select="$lang"/></xsl:with-param>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>

  </xsl:if>

  </xsl:template>

  <xsl:template match="text()"/>

</xsl:stylesheet>

<!-- $Id: script_maker.xsl,v 1.7 2002/11/28 16:50:42 philippe Exp $ -->
