/*
 Copyright (C) 2002 MandrakeSoft SA
 
 This program may be distributed and/or
 modified under the terms of the GNU General Public
 License version 2 as published by the Free Software Foundation
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 Licensees holding valid MandrakeSecurity MNF Commercial License may use this
 file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
 provided with the Software.
 
 See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
*/ 
#include <stdio.h>
#include <stdlib.h>
#define _GNU_SOURCE
#include <getopt.h>

#include "compiler.h"
#include "backend.h"

struct option longopts[] =
  {
    { "help", no_argument, 0, 'h' },
    { "page-prefix", required_argument, 0, 'p' },
    { 0, 0, 0, 0 }
  };


static void usage(void);

int main(int argc, char *argv[])
{
  int optc;
  const char *page_prefix = 0;
  int h = 0, p = 0, i;

  while ((optc = getopt_long(argc, argv, "hp:", longopts, (int *) 0)) != -1)
    {
      switch (optc)
	{
	case 'h':
	  h = 1;
	  break;
	case 'p':
	  page_prefix = optarg;
	  p = 1;
	  break;
	}
    }

  if ((h) || (optind >= argc))
    {
      usage();
      exit(1);
    }

  if (p)
    wvm_set_page_prefix(page_prefix);
      
  for (i = optind;  i < argc; i++)
    wat_compile(argv[i]);

  exit(0);
}


static void usage(void)
{
  fprintf(stderr, "Usage: compiler [options] files ... \n");
  fprintf(stderr, "Options: -p prefix  (or --page-prefix prefix)\tset the page name prefix for show instruction\n");
  fprintf(stderr, "Options: -h  (or --help)\tshow this text\n");
}
