<?
/* Copyright (C) 2000,2001 Mandrakesoft                                  */
/* Authors :                                                             */
/* Renaud Chaillat <rchaillat@mandrakesoft.com>                          */
/* Enzo Maggi <emaggi@mandrakesoft.com>                                  */
/*                                                                       */
/*  $Id: naatengine.inc.php,v 1.13 2002/12/04 13:04:19 philippe Exp $                                                                 */

/*
 Copyright (C) 2002 MandrakeSoft SA
 
 This program may be distributed and/or
 modified under the terms of the GNU General Public
 License version 2 as published by the Free Software Foundation
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 Licensees holding valid MandrakeSecurity MNF Commercial License may use this
 file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
 provided with the Software.
 
 See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
*/ 

//	################
//	#  NAAT LIBRARY #
//	################
//

// Add specific backend function

/* function generate_php_popen
 *
 * popen() the code passed as argument and display 
 * its result line after line.
 *
 */
function generate_php_popen ($code)
{
  $descriptor = popen ("$code","r");

  while (!feof ($descriptor)) {
    $read_again = true;
    $buffer_size = 4096;
    $full = "";
    
    while ( !feof ($descriptor) && ($read_again) ) {
      $read_again = false;
      $line = fgets ($descriptor, $buffer_size);
      $full .= $line;
      if (strlen ($line) >= ($buffer_size - 1)) {
	if ( $line[($buffer_size - 2)] != '\n' ) {
	  $read_again = true;
	}
      }
    }
    print $full."<BR>";
    flush ();
  }

  pclose ($descriptor);

}

/* function generate_php_preload_variables
 *
 * Preload all variables specified in variables_list
 * with a single backend call.
 *
 */
function generate_php_preload_variables ($variables_list)
{
//	$debugfile = fopen ("DEBUGglobal","a");
 // Get the values from the backend
  global $md5;
//  print "<u>".$md5."</u>\n";


  $list = explode (',',$variables_list);

  // Look each variable name, and create two strings:
  // - one to get the value of all indirect values 
  // (like ${InternetInterface})
  // - the other to get all final values

  $final_string    = "";
  $indirect_string = "";

  // array to keep track of names, to be able to turn vars global
  unset ($indirect_names_list); 
  for ($i=0; $i<sizeof($list); $i++) {
    // Beware of variables like xxx[] which are named xxx only in the backend
    if ( preg_match("/(.+)\[\]/", $list[$i], $backend_name) ) { 
      $list[$i] = $backend_name[1];
    }

    // TODO: put each variable only once (not really harmful to put them several times, though)
    if ( $list[$i] != ""  && 
	 (! preg_match("/^frontend_.*/",$list[$i])) ) { // do not call the backend for frontend params
	  $final_string .= " --get ".$list[$i];
    }

    $tokens = explode ('$',$list[$i]);
    for ($j=0; $j<sizeof($tokens); $j++) {
      unset ($regs);
      if (ereg("\{(.+)\}.*",$tokens[$j],&$regs)) {
	if (!preg_match ("/^frontend_.*/",$regs[1])) { // do not call the backend for frontend params
	  $indirect_string .=" --get ".$regs[1];
	}
	$indirect_names_list[] = $regs[1]; // add at the end
      }
    }
  }

   // First get the indirect values and turn them global, 
  // to be able to evaluate the final values.
  if ($indirect_string != "") {
    unset ($ret);
    exec ("config-wrapper.pl ".$md5.$indirect_string,&$ret);
  }

  // -- Create the variables with their returned value and put them in the global scope --
  for ($i=0; $i<sizeof($indirect_names_list); $i++) {
    $name = $indirect_names_list[$i];
    eval("\$name = \"$name\";");
    global ${$name};
    if (! ${$name} ) { // Take care of frontend params (shouldn't be usefule here)
      ${$name} = $ret[$i];
    }
  }
  // -------------------------------------------------------------------------------------


  // Then get the final values
  if ($final_string !="" && $final_string != " --get ") {

    eval ("\$final_string = \"$final_string\";");

    unset ($ret);
    exec ("config-wrapper.pl ".$md5.$final_string,&$ret);
  }


  // -- Create the variables with their returned value and put them in the global scope --
  $backend_vars_index = 0;
  for ($i=0; $i<sizeof($list); $i++) {

//	fwrite ($debugfile,"* $i * Variable directe $name, valeur:".${$name}."\n");
//	fwrite ($debugfile,"Valeur retournee: $ret[$i] \n");

    eval("\$name = \"$list[$i]\";");
    global ${$name};
    if (! preg_match ("/^frontend_.*/",$name)) {
      ${$name} = $ret[$backend_vars_index];
	  $backend_vars_index++;
    }
  } 
  // -------------------------------------------------------------------------------------

//	fclose ($debugfile);

}

/* function variable_get_value
 *
 * Look if a variable is a frontend variable or a backend one,
 * and then return its value.
 */
function variable_get_value ($variable_name)
{
  global ${$variable_name};

  if ( isset(${$variable_name}) ) { // even if it's empty
    if (${$variable_name} == "---") { // empty variable as told by the backend
      return "";
    }
    if (${$variable_name} == "-*-") { // unknown variable as told by the backend
      return "n/a";
    }
    return ${$variable_name};
  }

  // If the variable does not exist in memory, call the backend 

  // But not if it is specifically a frontend variable
  if ( preg_match("/^frontend_/",$variable_name) ) { return; }

  global $md5;
  unset($ret);
  exec("config-wrapper.pl ". $md5 ." --get " .  $variable_name, &$ret);

  if ($ret[0] == "---") { // empty variable as told by the backend
    return "";
  }
  if ($ret[0] == "-*-") { // unknown variable as told by the backend
    return "n/a";
  }
  return $ret[0];
}



/* function dereference_compound_variablename ($variable_name)
 *
 * Turn a composed variable name like ${fontend_param1}IP
 * into its real name (first eval the parts, i.e. ${frontend_param1}
 * becomes Eth0 for example)
 */ 
function dereference_compound_variablename ($variable_name)
{
  global $md5; // Transaction ID
  
  unset ($var);
  $variable = "$variable_name";
  $list = explode("\$", $variable);

  /* Analyze the variable name and get the value of each 
   * part of the name (e.g. ${interface}IP => $Eth0IP)
   */
  for ($i=0;$i<sizeof($list); $i++)
    {  
      unset ($regs);
      if (ereg("\{(.+)\}(.*)", $list[$i], &$regs))
	{
	  $var .= variable_get_value ($regs[1]) . $regs[2];
	}  
      else 
	{
	  $var .= $list[$i];
	}
    }
  
  return $var;
}


/* display_parameterized_actions
 * 
 * Used to display text or image links on each row of a list.
 * This allows to have actions taking the first column item as a parameter.
	*  * add: button_actions variable
 */
function display_parameterized_actions ($param_actions,$parameter,$button_actions,$variable,$row_type)
{
  if ( $param_actions != "" ) {
    unset($actions);
    $actions = explode (',',$param_actions);
			    
    // Process each action
    for ($action_index=0; $action_index<count($actions); $action_index++) {
      unset($regs);
      unset($href);
      ereg("(.+) \((.+)\)", $actions[$action_index], &$regs);
      // $regs[1] is the href, $regs[2] is value and type

      unset($action_modifiers);
      preg_match_all ("/(\S+)\s*=\s*(\S+)/",$regs[2],$action_modifiers,PREG_PATTERN_ORDER);
      // Now $action_modifiers[1] is an array of labels, and 
      // $action_modifiers[2] is an array of corresponding values

      $value = $action_modifiers[2][0];
			$type = $action_modifiers[2][1];
			$image = $action_modifiers[2][2];

      $href .= $regs[1];
      $href = str_replace ("&amp;","&",$href);
      // replace ' ' by %20
      $parameter = str_replace(' ', '%20', $parameter);
      $href .= "&frontend_param1=".$parameter;

      if ($variable) { $href .= "&frontend_param2=".$variable; }

      switch ($type) {
	      case "text":
	      print "<td class=\"tabcont".$row_type."\" valign=\"top\"><".$href."\">".string_decrypt($value)."</A></td>\n";
	      break;

	      case "image":
		      print "<td class=\"tabcont".$row_type."\" valign=\"top\"><".$href."\"><img src=\"".$image."\" border=\"0\"/></A></td>\n";
	      break;
      }
    }
  } 
		if ( $button_actions != "" ) {
			unset($actions);
			$actions = explode (',',$button_actions);

			// Process each action
			for ($action_index=0; $action_index<count($actions); $action_index++) {
				unset($regs);
				unset($href);
				ereg("(.+) \((.+)\)", $actions[$action_index], &$regs);
				// $regs[1] is the href, $regs[2] is name,value and type

				unset($action_modifiers);
				preg_match_all ("/(\S+)\s*=\s*(\S+)/",$regs[2],$action_modifiers,PREG_PATTERN_ORDER);
				// Now $action_modifiers[1] is an array of name, and 
				// $action_modifiers[2] is an array of corresponding values
				// $action_modifiers[3] is an array of corresponding type (text or image)
				// $action_modifiers[4] is an array of corresponding image name if (type = image)

				$name = $action_modifiers[2][0];
				$value = $action_modifiers[2][1];
				$type = $action_modifiers[2][2];
				$image = $action_modifiers[2][3];

				$href .= $regs[1];
				$href = str_replace ("&amp;","&",$href);
				// replace ' ' by %20
				$parameter = str_replace(' ', '%20', $parameter);
				$href .= "&frontend_param1=".$parameter;
				//      print "<td class=\"tabcont0\" valign=\"top\"><".$href."\">".$value."</A></td>\n";
				switch ($type) {
					case "text":
						print "<td class=\"tabcont".$row_type."\" valign=\"top\"> <input type=\"submit\" alt=\"[".$value."]\" title=\"".$value."\" border=\"0\" name=\"".$name."\" value=\"".$value."\"> </td>\n";
					break;

					case "image":
						print "<td class=\"tabcont".$row_type."\" valign=\"top\"> <input type=\"image\" src=\"".$image."\" alt=\"[".$value."]\" title=\"".$value."\" border=\"0\" name=\"".$name."\" value=\"".$value."\"> </td>\n";
					break;
				}
			}
		}


}


/* decrypt
 *
 * Handle some special characters received as ASCII values like %13 => \n
 * Allows to receive descriptions for packages, for example
 */
function string_decrypt ($string)
{
  unset ($result_string);

  $result_string = str_replace ("%09","\t",$string);
  $result_string = str_replace ("%13","<br>",$result_string);
  $result_string = str_replace ("%10","\r",$result_string);
  $result_string = str_replace ("%20"," ",$result_string);
  $result_string = str_replace ("%21","!",$result_string);
  $result_string = str_replace ("%22","\"",$result_string);
  $result_string = str_replace ("%23","#",$result_string);
  $result_string = str_replace ("%24","<p>",$result_string);
  $result_string = str_replace ("%26","&amp;",$result_string);
  $result_string = str_replace ("%27","'",$result_string);
  $result_string = str_replace ("%28","(",$result_string);
  $result_string = str_replace ("%29",")",$result_string);
  $result_string = str_replace ("%2A","*",$result_string);
  $result_string = str_replace ("%2B","+",$result_string);
  $result_string = str_replace ("%2C",",",$result_string);
  $result_string = str_replace ("%2D","-",$result_string);
  $result_string = str_replace ("%2E",".",$result_string);
  $result_string = str_replace ("%2F","/",$result_string);
  $result_string = str_replace ("%25","%",$result_string); // this one should be the last !!!

  // bold for lines labels (but beware of lines such as ftp://* or http://*)
  // First line (of a long description, for example)
  $result_string = preg_replace ("/(^[^\d:]+:)([^\/])/","<b>\\1</b>\\2",$result_string); // Put in bold 'xxx:' but not 'xxx:/' nor '09:30'
  // Other lines (detect html line breaks that have just replaced all %13, see above)
  $result_string = preg_replace ("/<br>([^\d:<]+:)([^\/])/","<p><b>\\1</b>\\2",$result_string); // Nearly the same as above

  return $result_string;
}


/* generate_php_get_variable(variable,input_type,action,type_field)
 *
 * Execute the backend call with the specific variable/action
 * and print the input/output text Field
 * <input type="text" size="30" maxlength="20" name="AdminName" value="..."
 */
function generate_php_get_variable($variable_name,$input_type,$action_name,$type_field,$value,$size)
{
  global $md5; // Transaction ID
  
  $result = "";
  
  // Get the value to display :
  // - the variable content if it exists
  // - else the result of the action provided
  unset($array_result);
  if ($variable_name) {
    $var = dereference_compound_variablename ($variable_name);
    $result = variable_get_value($var);	// Precedes any action to not overwrite an existing value
  }
  if ($action_name && $result=="") {
    exec("".$action_name , &$array_result, &$ret); // $action_name is evaled ?
    $result = $array_result[0];
    $result = string_decrypt ($result);
  } 

  // If the result is empty and a default value is provided, we set the result to the value
  if ($value && $result=="") {
    $result = dereference_compound_variablename ($value); // in case the value is a variable name
  }
  
  $result = string_decrypt ($result);

  if (!$size) { $size="30"; }

  switch ($type_field) {
  case "Input":
    print "<input type=\"".$input_type."\" size=\"".$size."\" maxlength=\"250\" name=\"".$var."\" value=\"".$result."\">\n";
    break;
    
  case "Output":

			if ($input_type == "list") {
				unset ($list);
				unset ($result_list);
				$list = explode (',',$result);

				// Process each element
				for ($action_index=0; $action_index<count($list); $action_index++) {
					unset($regs);
					if (ereg("(.+) \((.+)\)", $list[$action_index], &$regs)) {
						// $regs[1] is the item, $regs[2] is attribute
						$result_list .= $regs[1];
					} else {
						$result_list .= $list[$action_index];
					}
						if ($action_index < count($list)-1) {$result_list .= ","; }

				}
				$result=$result_list;
			}

    print $result."\n";
    break;
  }
}

/* function generate_php_option ($variable_name,$type,$value,$default,$label)
 *
 * Generate an option in static selectable lists.
 * Is also used to generate hidden input.
 */
function generate_php_option ($variable_name,$type,$value,$default,$label)
{
  unset ($var);
  unset ($arraylist);
  
  $real_name = dereference_compound_variablename($variable_name);
  
  // look for an already queried variable
  if (preg_match("/(.+)\[\]/", $real_name, $var_name)) {
    $$real_name = variable_get_value ($var_name[1]);      
  }
  else {
    $$real_name = variable_get_value ($real_name);
  }


  // Value can also be compound (e.g. ${frontend_param1})
  $value = dereference_compound_variablename($value);
  
  $checked = "";
  $elem = explode (",", $value);
  /* different comportement if value is a list of elem seperate by comma */
  if (count($elem) > 1) { 
    /* The option is a list, we need to check if each elem is in the list */
    $checked = " checked";
    for ($k=0; $k<count($elem); $k++) {
      if (!preg_match("/".  $elem[$k] ."/i", $$real_name )) {
	$checked = "";
      }      
    }
    if ($checked == "" && $default == "yes" && (!$$real_name || $$real_name=="")) {
      $checked = " checked";
    }
  }
  else {
    /* The option is a single composant */
    if ( preg_match(";". $value .";i", $$real_name) ) {
      $checked = " checked"; 
    } else if ($default == "yes" && (!$$real_name || $$real_name=="")) {
      $checked = " checked"; 
    }
  }
  
  // Build the correct html 'list option' on account of the type
  switch ($type) {
  case "Boolean":
    print "<tr valign=\"top\"><td class=\"tabcont0\" valign=\"top\"><input type=\"radio\" name=\"".$real_name."\" value=\"".$value."\"".$checked.">".$label."</td></tr>\n";
    break;
    
  case "Checkbox":
    print "<tr valign=\"top\"><td class=\"tabcont0\" valign=\"top\"><input type=\"checkbox\" name=\"".$real_name."\" value=\"".$value."\"".$checked.">".$label."</td></tr>\n";
    break;
    
  case "Hidden":
    print "<input type=\"hidden\" name=\"".$real_name."\" value=\"".$value."\">\n";
    break;
    
  default: // List case
    if ($checked == " checked") {
	$checked = " selected";
    }
    print "<option value=\"".$value."\"".$checked.">".$label."</option>";
    break;
  }
}


/* function generate_php_get_list (variable,input_type,action,type_field)
 *
 * Execute the backend call with the specified variable or actions
 * and print the html result 
 */
function generate_php_get_list($variable_name,$input_type,$action_name,$param_actions)
{
  global $md5; // Transaction ID

  unset ($var);
  unset ($arraylist);

  $row_type = 1;  // is this a even or odd row ?
  $real_name = dereference_compound_variablename($variable_name);

  // Get the output of the action in a list (i.e. build the dynamic list)
  if ( isset ($action_name) && $action_name != "" ) {
    exec("".$action_name , &$arraylist , &$var); // $action_name is evaled ?
    $list = explode (",", $arraylist[0]);
  } else {
    print "<!-- get_list: empty action name -->\n";
    return;
  }

  // Handle error cases like empty lists
  if ($list[0] == "" || (sizeof ($list) == 1 && $list[0] == "---") ) {
    print "<tr valign=\"top\"><td class=\"tabcont".$row_type."\" valign=\"top\"> Empty list... </td></tr>\n";
    return;
  }

  switch ($input_type) {
  case "Boolean":
    $real_type = "radio";
  break;

  case "Checkbox":
    $real_type = "checkbox";
  break;

  default :
    $real_type = "false";
  break;
  }

  $label_flag = 0; // Used when dealing with attributes

  // Build the correct html list on account of the type
  for ($k=0; $k<count($list); $k++) {

    // Process item attributes (i.e.  item1 (attr1=val attr2=val) )
    unset($tokens);
    unset($attributes);
    if (preg_match("/\s*(\S+)\s*\((.+)\)\s*/", $list[$k], &$tokens)) {
      $item = $tokens[1];
      // Put attributes labels and values in an array
      preg_match_all ("/(\S+)\s*=\s*(\S+)/",$tokens[2],$attributes,PREG_PATTERN_ORDER);
      // Now $attributes[1] is an array of labels, and 
      // $attributes[2] is an array of corresponding values
    } else {	    
      $item = $list[$k];
    }

    $item = string_decrypt ($item);

    if ($real_type == "false") {
//      $item = ucfirst($item);
      print "<option value=\"".$item."\" selected>".$item."</option>";
      continue; // Current item is complete
    }

    // If there are attributes to display, create a row for labels
    if ($attributes[1] && $label_flag==0) {
      $label_flag = 1;
      print "<tr valign=\"top\"><td class=\"tabtitle\" valign=\"top\"> </td>"; // Emtpy first cell
      for ($attr_index=0; $attr_index < count ($attributes[1]); $attr_index++) {
	$attributes[1][$attr_index] = string_decrypt ($attributes[1][$attr_index]);
	print "<td class=\"tabtitle\" valign=\"top\"> ".$attributes[1][$attr_index]." </td>";
      }
      print "</tr>\n";
    }

    print "<tr valign=\"top\">\n";
    print "<td class=\"tabcont".$row_type."\" valign=\"top\"><input type=\"".$real_type."\" name=\"".$real_name."\" value=\"".$item."\"> ".$item."</td>";

    // Display attributes values if any
    if ($attributes[1]) {
      for ($attr_index=0; $attr_index < count ($attributes[2]); $attr_index++) {
	print "<td class=\"tabcont".$row_type."\" valign=\"top\"> ".$attributes[2][$attr_index]." </td>";
      }
    }

    // Are there actions to append on each line ?
    //	print "Parameter: $param_actions";
    display_parameterized_actions ($param_actions, $item ,"", "", $row_type);
   $row_type = ($row_type + 1) %2;
    print "</tr>\n";
  } // End for loop

  return;
}



/* generate_php_get_dyntable
 *
 * Test function for dynamic tables 
 * $action_name : string describing the shell script to execute 
 *                to get a comma separated list of values.
 *                These values are a list of variable names that will serve as 
 *                a prefix (ex.: eth0, eth1)
 * $variable_name : variable to use instead of $action_name to retrieve the list.
 * $href_action : a string to indicate the action number associated with 
 * 		  the prefix (e.g. "action1")
 *                If there's no action associated, it's set to "false" by xsl.
 *                Typically we put a HREF to an action on the prefix, for instance
 *                <A HREF="../engine.php?file=test/test.wvm&cmd=Next&action1=true">eth0</A>
 * $fields_string : stringified list of parameters 
 *                  label1,suffix1:type:action1,label2,suffix2:type,label3,suffix3:type:action2
 *                  (action is optional and is used to generate a 'href' action)
 *
 * $param_actions : list of actions to put on each row
	*
	* $button_actions: 
	* $button_actions="INPUT (name=action2 value=Modify type=image imgname=images/file_pencil.gif),INPUT (name=action3 value=Delete type=text)";

 */
function generate_php_get_dyntable($action_name,$variable_name,$href_action,$fields_string,$param_actions,$button_actions,$attribut_string)
{
  global $md5; // Transaction ID

  unset ($var);
  unset ($variable);
  unset ($arraylist);

  $row_type = 1;  // is this a even or odd row ?

  // Get the current wvm file
  global $file;

  // Execute the action to retrieve a list from a backend variable
  if ($action_name) {
    exec("".$action_name , &$arraylist , &$var);
    $list     = explode (",", $arraylist[0]);
  } else {
    // Frontend or backend variable ?
	$variable=dereference_compound_variablename($variable_name);
    $list = explode (",", variable_get_value($variable));
  }

  // Handle error cases like empty lists
  if ($list[0] == "") {
    print "<tr valign=\"top\"><td class=\"tabtitle\" valign=\"top\"> </td></tr><tr valign=\"top\"><td class=\"tabcont0\" valign=\"top\"> Empty list... </td></tr>\n";
    return;
  }
  // Analyze the fields string
  if ($fields_string != "") {
    $items    = explode (",", $fields_string);

    // Build needed arrays for labels, constructed variable names and 
    // actions (one for each field column)
    for ($item_index=0; $item_index < count ($items) / 2; $item_index++) {
      unset ($value);
      unset ($param);
	    
      $label[$item_index]  = $items[2*$item_index];

      $tokens = explode (":", $items[2*$item_index+1]);
      $suffix[$item_index] = $tokens[0];

      if ($tokens[1]) { // Should always be the case since the default type is text in dtd
	$type[$item_index] = $tokens[1];
      }
      if ($tokens[2]) {
	$action[$item_index] = $tokens[2];
      }
    }
  }

  // Analyze the attribut string
if ($attribut_string != "") {
	unset($attribut_label);
	unset($attribut_value);
    $items    = explode (",", $attribut_string);

    // Build needed arrays for labels, constructed variable names and 
    // actions (one for each field column)
    for ($item_index=0; $item_index < count ($items) / 2; $item_index++) {
      $attribut_label[$item_index]  = $items[2*$item_index];

      $tokens = explode (":", $items[2*$item_index+1]);

      $attribut_value[$item_index] = $tokens[0];

      if ($tokens[1]) { // Should always be the case since the default type is text in dtd
	$type[$item_index] = $tokens[1];
      }
      if ($tokens[2]) {
	$action[$item_index] = $tokens[2];
      }
    }
  }
  
  // --- Generate headers ---
  print "<tr valign=\"top\"><td class=\"tabtitle\" valign=\"top\"> </td>\n"; // Empty first cell 

	// First: attribut labels
  if ($attribut_string != "") {
    for ($header_index=0; $header_index < count($attribut_label); $header_index++) {
//      $result=string_decrypt($attribut_label[$header_index]);
      print "<td class=\"tabtitle\" valign=\"top\">".string_decrypt($attribut_label[$header_index])."</td>\n";
    }
  } else {

  // First: attribute names (e.g. eth0 (Driver=3c59x Mac=00:00:00:00:00:00) )
  unset($regs);
  if ( preg_match("/\s*(\S+)\s*\((.+)\)/", $list[0], &$regs) ) {
    // $regs[1] is the prefix, $reg[2] is the list of attributes 
    unset($attributes);
    if ($regs[2]) {
      // Put attributes labels in an array
      preg_match_all ("/(\S+)\s*=\s*\S+/",$regs[2],$attributes,PREG_PATTERN_ORDER);
      // Now $attributes[1] is an array of labels
    }
    for ($attr_index=0; $attr_index < count ($attributes[1]); $attr_index++) {
      print "<td class=\"tabtitle\" valign=\"top\"> ".string_decrypt($attributes[1][$attr_index])." </td>"; // Display Header col (Label)
    }
  }; 
	}

  // Second: field labels
  if ($fields_string != "") {
    for ($header_index=0; $header_index < count($label); $header_index++) {
      print "<td class=\"tabtitle\" valign=\"top\">".string_decrypt($label[$header_index])."</td>\n";
      /*
	if ($header_index%5 == 0) {
	print "\n</tr>\n<tr valign=\"top\">\n";
	}
      */
    }
  }

  print "</tr>\n";
  // --- End headers ---

  // ** Generate the rows displayed **
  // For each prefix (e.g. for each ethernet card) 
  for ($prefix_index=0; $prefix_index < count($list); $prefix_index++) {
    $varname = $list[$prefix_index]; 
//    $varname = ucfirst ($varname);

    // See if the prefix has any attributes
    // (e.g. eth0 (Driver=3c59x Mac=00:00:00:00:00:00) ) 
    //
    if ( preg_match("/\s*(\S+)\s*\((.+)\)/", $varname, &$regs) ) {
      // $regs[1] is the prefix, $reg[2] is a list of attributes 
      $varname = $regs[1];
    }; 

    // Print the prefix in the first column, possibly with a href action
    print "<tr valign=\"top\"><td class=\"tabcont".$row_type."\" valign=\"top\">\n";
    if ( $href_action != "false" ) {
      $href_action = str_replace ("&amp;","&",$href_action);
      print "<$href_action&frontend_param1=$varname\">".string_decrypt($varname)."</A>\n";
    } else {
      print string_decrypt($varname)."\n"; // Prefix (start of ligne)
    }
    print "</td>\n";

		if ($attribut_string != "") {
			unset ($param);
			unset ($value);
			unset ($param);
			for ($suffix_index=0; $suffix_index < count ($attribut_value); $suffix_index++) {

				$split_attribut  = explode (" ", $attribut_value[$suffix_index]);

				unset ($param);
				unset ($value);
				unset ($param);
				if ($regs[2]) { // Put attributes labels in an array
					preg_match_all ("/(\S+)\s*=\s*\S+/",$regs[2],$attributes,PREG_PATTERN_ORDER);
					preg_match_all ("/\S+\s*=\s*(\S+)/",$regs[2],$value,PREG_PATTERN_ORDER);

					unset ($display_value);
					$separator="";
					for ($split_index=0; $split_index < count ($split_attribut); $split_index++) {

					for ($attr_index=0; $attr_index < count ($attributes[1]); $attr_index++) {
						// Now $attributes[1] is an array of labels
							if ( ($attributes[1][$attr_index] == $split_attribut[$split_index]) && 
									!(preg_match("/^(\-+)/", $value[1][$attr_index]) ) ){
								//										 if ($attributes[1][$attr_index] == $attribut_value[$suffix_index]){
								//								print "<td class=\"tabcont0\" valign=\"top\" align=\"center\">".$value[1][$attr_index]."</td>\n";
								$display_value .= $separator.$value[1][$attr_index];
								$separator=":";
							}
						}
					}
						print "<td class=\"tabcont".$row_type."\" valign=\"top\" align=\"left\">".string_decrypt($display_value)."</td>\n";
				}

				// Get in variable $variable the attribut_value of $varname
				// ex: variable=varname (attribut=value)
				//						$param = "$variable $varname $attribut_value[$suffix_index]";
				//exec("config-wrapper.pl ". $md5 ." -lg ".$param, &$value, &$var);
				//
				//						print "<td class=\"tabcont0\" valign=\"top\">$value[0]</td>\n";
			} 
		}	  else {

    // Print attributes values
    if ($regs[2]) {
      // Put attributes labels in an array
      preg_match_all ("/\S+\s*=\s*(\S+)/",$regs[2],$attributes,PREG_PATTERN_ORDER);
      // Now $attributes[1] is an array of attributes values
    }
    for ($attr_index=0; $attr_index < count ($attributes[1]); $attr_index++) {
      print "<td class=\"tabcont".$row_type."\" valign=\"top\"> ".string_decrypt($attributes[1][$attr_index])." </td>"; // Cross between (Lign&col)
    }
}

    // Get all text fields values for the current prefix at once 
    if ($fields_string != "") {
      unset ($param);
      for ($suffix_index=0; $suffix_index < count ($suffix); $suffix_index++) {
	if ($type[$suffix_index]!="image") {
	  $param .= "$varname$suffix[$suffix_index] ";
	}
      }
      unset ($value);
      exec("config-wrapper.pl ". $md5 ." --mget ".$param, &$value, &$var);

      // Print all values in separate columns
      unset ($dynamic_images_path);
      $values = explode (";",$value[0]); // previous separator ,
      for ($suffix_index=0; $suffix_index < count ($suffix); $suffix_index++) {
	// See if it's a text value or an image path and display it
	if ($type[$suffix_index] == "image") {
	  // Get the path to images (monitoring graphs for instance)
	  if (! $dynamic_images_path) {
	    exec("config-wrapper.pl ". $md5 ." --get DynamicImagesPath", $dynamic_images_path, &$var);
	  }
	  // Compute the image name
	  $image_name = strtolower($varname)."-".strtolower($suffix[$suffix_index]).".png";
	  print "<td class=\"tabcont".$row_type."\" valign=\"top\"><img src=\"".$dynamic_images_path[0]."/".$image_name."\"/></td>\n";
	} else {
	  print "<td class=\"tabcont".$row_type."\" valign=\"top\">".string_decrypt($values[$suffix_index])."</td>\n";
	}
      }
    }	

    // Print parameterized actions
    display_parameterized_actions ($param_actions, $varname, $button_actions, $variable,$row_type);

   $row_type = ($row_type + 1) %2;
    print "</tr>";
  }

}



?>
