# $Id: naat-frontend-www.spec,v 1.38 2002/09/26 16:15:21 philippe Exp $
%define name naat-frontend-www
%define version 0.8
%define release 24mdk

%define admroot /var
%define apacheadmroot %{admroot}/www-naat
%define adminroot secure
%define sessions sessions

%define novpn 0
%define vpnserver 0
%define vpnclient 0

%{?_with_novpn: %{expand: %%define novpn 1}}
%{?_with_vpnserver: %{expand: %%define vpnserver 1}}
%{?_with_vpnclient: %{expand: %%define vpnclient 1}}

Summary: The pages of the front-end in the NAAT project
Name: %{name}
Version: %{version}
Release: %{release}
License: GPL
Url:		http://www.mandrakesecure.net
Group: System/Configuration/Other
Source: %{name}-%{version}.tar.bz2
Buildroot: %{_tmppath}/%{name}-%{version}
BuildArchitectures: noarch
Prefix: %{_prefix}
BuildRequires: libxml
BuildRequires: libxml-devel
#BuildRequires: xalan-c
#BuildRequires: xerces-c
BuildRequires: libxslt1-devel
BuildRequires: libxslt-proc
BuildRequires: gcc
BuildRequires: make
PreReq: naat-backend
# nope: we want /var/www-naat/html/admin to be a link
# naat-monitoring would create a real dir instead
#PreReq: naat-monitoring
PreReq: httpd-naat
#PreReq: mandrake_doc_security-en
#Requires: curl
#Requires: squid
#Requires: squidGuard
##Requires: bind
#Requires: dhcp-server
#Requires: ipvsadm
#Requires: iptoip
#Requires: diald

%description
A set of configuration pages for the
Network Appliance Administration Tool on Mandrake Linux Server.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q
mkdir -p ${RPM_BUILD_DIR}/%{name}-devel/
tar -jxf ${RPM_SOURCE_DIR}/%{name}-%{version}.tar.bz2 -C ${RPM_BUILD_DIR}/%{name}-devel/


%build
%if %{vpnserver}
cp -f modules/index-vpnserver.frontend.xml modules/index.frontend.xml
%endif
%if %{vpnclient}
cp -f modules/index-vpnclient.frontend.xml modules/index.frontend.xml
%endif
%if %{novpn}
cp -f modules/index-adv.frontend.xml modules/index.frontend.xml
%endif

make post-trad
make 
for i in fr de it pt es; do
ln -sf ../modules/dtd/ modules-${i}/
if [ -d modules-help/${i} ]; then
MODULES_HELP="modules-help/${i}"
else
MODULES_HELP="modules-help/en"
fi
make MODULES="modules-${i}" DEST="naat-${i}" ONLINE_HELP="help-${i}" MODULES_HELP="${MODULES_HELP}"
done

%install
# clean file list
rm -rf file.list.{en,fr,de,it,pt,es}
make DESTDIR=${RPM_BUILD_ROOT} HTTPD_DEST=${RPM_BUILD_ROOT}/var/www-naat/html/ LANGUAGE=en MODULES_HELP="modules-help/en" install_all

#install -m600 SOURCES/dot-htaccess $RPM_BUILD_ROOT/%{apacheadmroot}/html/en/%{adminroot}/.htaccess

find ${RPM_BUILD_ROOT} -type d | sed -e "s!${RPM_BUILD_ROOT}!%attr(750,httpd-naat,admin) %dir !" | grep "/var/www-naat/html/en" >> file.list.en
find ${RPM_BUILD_ROOT} -type f | sed -e "s!${RPM_BUILD_ROOT}!!" | grep "/var/www-naat/html/en" >> file.list.en
perl -pi -e 's!(.*php$)!%attr(400,httpd-naat,admin) $1!' file.list.en
perl -pi -e 's!(.*wvm$)!%attr(400,httpd-naat,admin) $1!' file.list.en
perl -pi -e 's!(.*html$)!%attr(400,httpd-naat,admin) $1!' file.list.en
perl -pi -e 's!(.*png$)!%attr(400,httpd-naat,admin) $1!' file.list.en
perl -pi -e 's!(.*gif$)!%attr(400,httpd-naat,admin) $1!' file.list.en

for i in fr de it pt es; do
	make MODULES="modules-${i}" DEST="naat-${i}" ONLINE_HELP="help-${i}" DESTDIR=${RPM_BUILD_ROOT} HTTPD_DEST=${RPM_BUILD_ROOT}/var/www-naat/html/ LANGUAGE=${i} MODULES_HELP="modules-help/${i}" install_all
#	install -m600 SOURCES/dot-htaccess $RPM_BUILD_ROOT/%{apacheadmroot}/html/${i}/%{adminroot}/.htaccess
 find ${RPM_BUILD_ROOT} -type d | sed -e "s!${RPM_BUILD_ROOT}!%attr(750,httpd-naat,admin) %dir !" | grep "/var/www-naat/html/${i}" >> file.list.${i}
	find ${RPM_BUILD_ROOT} -type f | sed -e "s!${RPM_BUILD_ROOT}!!" | grep "/var/www-naat/html/${i}" >> file.list.${i}
	perl -pi -e 's!(.*php$)!%attr(400,httpd-naat,admin) $1!' file.list.${i}
	perl -pi -e 's!(.*wvm$)!%attr(400,httpd-naat,admin) $1!' file.list.${i}
	perl -pi -e 's!(.*html$)!%attr(400,httpd-naat,admin) $1!' file.list.${i}
	perl -pi -e 's!(.*png$)!%attr(400,httpd-naat,admin) $1!' file.list.${i}
	perl -pi -e 's!(.*gif$)!%attr(400,httpd-naat,admin) $1!' file.list.${i}
done

mkdir -p $RPM_BUILD_ROOT%{_prefix}/src/{name}-devel
cp -dpR ${RPM_BUILD_DIR}/%{name}-devel/* $RPM_BUILD_ROOT%{_prefix}/src/%{name}-devel/

%clean
rm -rf $RPM_BUILD_ROOT

%package en
Summary: The pages of the front-end in the NAAT project
Group: System/Configuration/Other
PreReq: naat-frontend-www-common
#PreReq: mandrake_doc_security-en
Requires: locales-en

%package fr
Summary: Les pages web du projet NAAT
Group: System/Configuration/Other
PreReq: naat-frontend-www-common
#PreReq: mandrake_doc_security-fr
Requires: locales-fr

%package de
Summary: The pages of the front-end in the NAAT project
Group: System/Configuration/Other
PreReq: naat-frontend-www-common
#PreReq: mandrake_doc_security-de
Requires: locales-de

%package it
Summary: The pages of the front-end in the NAAT project
Group: System/Configuration/Other
PreReq: naat-frontend-www-common
#PreReq: mandrake_doc_security-it
Requires: locales-it

%package es
Summary: The pages of the front-end in the NAAT project
Group: System/Configuration/Other
PreReq: naat-frontend-www-common
#PreReq: mandrake_doc_security-es
Requires: locales-es

%package pt
Summary: The pages of the front-end in the NAAT project
Group: System/Configuration/Other
PreReq: naat-frontend-www-common
#PreReq: mandrake_doc_security-pt
Requires: locales-pt

%package common
Summary: Common pages of the front-end in the NAAT project
Group: System/Configuration/Other
PreReq: naat-backend
PreReq: httpd-naat
Provides: naat-frontend-www

%package doc
Summary: The pages of the front-end in the NAAT project
Group: System/Configuration/Other

%package devel
Summary: Development package of the front-end in NAAT project
Group: Development/Other
Requires: libxml
Requires: libxml-devel
Requires: libxslt1-devel
Requires: libxslt-proc
Requires: gcc
Requires: make

%description common
A set of common configuration pages for the
Network Appliance Administration Tool on Mandrake Linux Server.

%description en
A set of configuration pages for the
Network Appliance Administration Tool on Mandrake Linux Server.

%description fr
Un ensemble de page de configuration pour l'outil
Network Appliance Administration Tool sur les serveurs Mandrake Linux.

%description de
A set of configuration pages for the
Network Appliance Administration Tool on Mandrake Linux Server.

%description it
A set of configuration pages for the
Network Appliance Administration Tool on Mandrake Linux Server.

%description es
A set of configuration pages for the
Network Appliance Administration Tool on Mandrake Linux Server.

%description pt
A set of configuration pages for the
Network Appliance Administration Tool on Mandrake Linux Server.

%description doc
A set of configuration pages for the
Network Appliance Administration Tool on Mandrake Linux Server.

%description devel
A set of development tools of the 
Network Appliance Administration Tool on Mandrake Linux Server.
This project use xslt-proc for pre-processing pages

%post common
chown httpd-naat.admin /var/www-naat/html/ -R
if [ -d /var/www-naat/%{sessions} ]; then
 find   /var/www-naat/%{sessions}/ -type f -exec rm -rf {} \;
fi

%post fr
# documentation
if [ ! -e /var/www-naat/html/fr/%{adminroot}/doc ]; then
	ln -fs /usr/share/doc/mandrake/fr /var/www-naat/html/fr/%{adminroot}/doc
fi

%post en
# documentation
if [ ! -e /var/www-naat/html/en/%{adminroot}/doc ]; then
	ln -fs /usr/share/doc/mandrake/en /var/www-naat/html/en/%{adminroot}/doc
fi

%post de
# documentation
if [ ! -e /var/www-naat/html/de/%{adminroot}/doc ]; then
	ln -fs /usr/share/doc/mandrake/de /var/www-naat/html/de/%{adminroot}/doc
fi

%post es
# documentation
if [ ! -e /var/www-naat/html/es/%{adminroot}/doc ]; then
	ln -fs /usr/share/doc/mandrake/es /var/www-naat/html/es/%{adminroot}/doc
fi

%post pt
# documentation
if [ ! -e /var/www-naat/html/pt/%{adminroot}/doc ]; then
	ln -fs /usr/share/doc/mandrake/pt /var/www-naat/html/pt/%{adminroot}/doc
fi

%post it
# documentation
if [ ! -e /var/www-naat/html/it/%{adminroot}/doc ]; then
	ln -fs /usr/share/doc/mandrake/it /var/www-naat/html/it/%{adminroot}/doc
fi

%files common
%defattr(-,httpd-naat,admin)
%attr(750,httpd-naat,admin) %dir /var/www-naat
%attr(750,httpd-naat,admin) %dir /var/www-naat/sessions
%attr(750,httpd-naat,admin) %dir /var/www-naat/trial
%attr(750,httpd-naat,admin) %dir /var/www-naat/html
%attr(600,httpd-naat,admin) /var/www-naat/html/*.php
%attr(750,httpd-naat,admin) %dir /var/www-naat/html/genfiles
%attr(750,httpd-naat,admin) %dir /var/www-naat/html/genfiles/modules
%attr(750,httpd-naat,admin) %dir /var/www-naat/html/images
%attr(600,httpd-naat,admin) /var/www-naat/html/images/*.png
%attr(750,httpd-naat,admin) %dir /var/www-naat/html/css
%attr(600,httpd-naat,admin) /var/www-naat/html/css/*.css
%attr(750,httpd-naat,admin) %dir /var/www-naat/html/php
%attr(600,httpd-naat,admin) /var/www-naat/html/php/*.php

%files en -f file.list.en
%defattr(-,httpd-naat,admin)

%files fr -f file.list.fr
%defattr(-,httpd-naat,admin)

%files de -f file.list.de
%defattr(-,httpd-naat,admin)

%files it -f file.list.it
%defattr(-,httpd-naat,admin)

%files es -f file.list.es
%defattr(-,httpd-naat,admin)

%files pt -f file.list.pt
%defattr(-,httpd-naat,admin)

%files doc
%defattr(-,root,root)
%doc  doc/ examples/ xsl/ SOURCES/dot-htaccess

%files devel
%defattr(-,root,root)
%doc  doc/ examples/ xsl/ SOURCES/dot-htaccess
%dir %{_prefix}/src/%{name}-devel
%{_prefix}/src/%{name}-devel/*

%changelog
*  Mon Jul 15 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-24mdk
- fix i18n

* Fri Jun 28 2002 Florin <florin@mandrakesoft.com> 0.8-23mdk
- vpn fixes, misc fixes

*  Wed Jun 26 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-22mdk
- fix time,internet acces, monitoring, rules, vpn

*  Tue Jun 18 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-20mdk
- vpn working version

* Thu May 02 2002 Florin <florin@mandrakesoft.com> 0.8-18mdk
- class_php fix(amaury), more vpn stuff, not yet ready (florin)

*  Tue Apr 30 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-17mdk
- vpn(florin), i18n(amaury), bugfixes, new path

*  Fri Apr 19 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-16mdk
- fix vpn, helpURL, added helpPage, add ProtocolList, PortList

*  Wed Apr 17 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-15mdk
- fix DynDns, backup, typo, help pages

*  Tue Apr 16 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-14mdk
- ez-ipupdate, traduction, helppages

*  Mon Mar 18 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-11mdk
- fix InternetStatus, default selected options, sumtraffic

*  Fri Mar 15 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-10mdk
- fix typo, monitoring, squid

*  Fri Mar 15 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-9mdk
- new layout, florin fixes (squid)

*  Wed Mar 13 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-8mdk
- fix new Layout

*  Fri Mar 08 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-7mdk
- new  style (First step)

*  Thu Mar 07 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-6mdk
- new features, new style (first step), beta version

*  Mon Feb 18 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-3mdk
- New Version: shorewall, New services

*  Mon Feb 11 2002 Philippe Libat <philippe@mandrakesoft.com> 0.8-2mdk
- Add shorewall, fix lot of bugs

*  Wed Dec 19 2001 Philippe Libat <philippe@mandrakesoft.com> 0.8-1mdk
- fix release

*  Wed Dec 19 2001 Philippe Libat <philippe@mandrakesoft.com> 0.7-1mdk
- Version snf

* Tue Nov 06 2001 Philippe Libat <philippe@mandrakesoft.com> 0.6-2mdk
- move prereq in snf package

* Mon Aug 27 2001 Renaud Chaillat <rchaillat@mandrakesoft.com> 0.6-1mdk
- updates for 8.1
- removed prereq on naat monitoring
- added provide naat-frontend-www in each translated package

*  Thu May 03  2001 Philippe Libat <philippe@mandrakesoft.com> 0.5-2mdk
- icones modification

*  Mon Apr 30  2001 Philippe Libat <philippe@mandrakesoft.com> 0.5-1mdk
- traduction integration

*  Thu Apr 3  2001 Philippe Libat <philippe@mandrakesoft.com> 0.4-6mdk
- prelude

*  Thu Mar 27  2001 Philippe Libat <philippe@mandrakesoft.com> 0.4-5mdk
- on line documentation (camille)
- leds (amaury)

*  Fri Mar 2  2001 Philippe Libat <philippe@mandrakesoft.com> 0.4-3mdk
- new release
- nulbanner, proxypac

*  Fri Feb 9  2001 Philippe Libat <philippe@mandrakesoft.com> 0.4-1mdk
- new menu: proxy, inputrules, monitoring, isdn
- cleanup scenarii

*  Mon Jan 29  2001 Philippe Libat <philippe@mandrakesoft.com> 0.3-14mdk
- g_internet switch case 

*  Fri Jan 26  2001 Philippe Libat <philippe@mandrakesoft.com> 0.3-12mdk
- lan mode, g_internet

*  Thu Jan 25  2001 Philippe Libat <philippe@mandrakesoft.com> 0.3-11mdk
- restrict, time, isdn, log

*  Wed Jan 24  2001 Philippe Libat <philippe@mandrakesoft.com> 0.3-10mdk
- output adsl, time

*  Mon Jan 22  2001 Philippe Libat <philippe@mandrakesoft.com> 0.3-8mdk
- schedule, adsl, inpu, output

*  Fri Jan 19  2001 Philippe Libat <philippe@mandrakesoft.com> 0.3-6mdk
- time

*  Wed Jan 17  2001 Philippe Libat <philippe@mandrakesoft.com> 0.3-5mdk
- add new modules

*  Mon Jan 15  2001 Philippe Libat <philippe@mandrakesoft.com> 0.3-4mdk
- new modules

*  Fri Jan 12  2001 Philippe Libat <philippe@mandrakesoft.com> 0.3-1mdk
- install directory
- permission

*  Wed Dec 20  2000 Philippe Libat <philippe@mandrakesoft.com> 0.2-2mdk
- requires php-gd

*  Fri Apr 14 2000 Philippe Libat <philippe@mandrakesoft.com> 0.1.1-1mdk
- initial spec file

