<!DOCTYPE xsl:stylesheet [
<!ENTITY % Entity SYSTEM "../modules-help/naat-help.dtd">
%Entity;
<!ENTITY nbsp    "&#x00A0;"> <!-- NO-BREAK SPACE -->
]>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:param name="wpofile"/>
<xsl:param name="helpname"/>
<!--
<xsl:output method="xml" encoding="iso-8859-1" indent="yes" omit-xml-declaration="yes"/>
-->
<xsl:output method="xml" encoding="iso-8859-1" indent="yes"/>

<xsl:template match="/">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="HelpPage[@name = $helpname]">
<xsl:comment> $Id: help2npo.xsl,v 1.4 2002/08/30 12:13:06 philippe Exp $ </xsl:comment>
<![CDATA[
<!DOCTYPE Wizard SYSTEM "../../modules/dtd/Naat.dtd"[
<!ENTITY % definition SYSTEM "../../modules/dtd/definition.ent">
%definition;
]>
]]>
<!--
<TRANSLATIONS>
-->
	<xsl:apply-templates/>
		<!--
  <TRANSLATE>
    <from>
      <xsl:value-of select="."/>
    </from>
     <to>
<xsl:variable name="path">
					<xsl:value-of select="concat('document($wpofile)//', name(), '[', count(preceding-sibling::*[name()=name(current())])+1, ']')" />
</xsl:variable>
					<xsl:value-of select="$path"/>
    </to>
  </TRANSLATE>

	</xsl:for-each>
</TRANSLATIONS>
-->
</xsl:template>

<!--
<xsl:template match="Introduction|Description|Title|Point|Option|Label">
-->
<xsl:template match="Introduction|Description|Title|Point|Option|Label">
  <TRANSLATE>
    <from>
      <xsl:value-of select="."/>
    </from>
     <to>
<xsl:variable name="name" select="name()" />
<xsl:variable name="position" select="count(preceding-sibling::*[name()=name(current())])+1" />
<xsl:variable name="path" select="concat('/', name(), '[', count(preceding-sibling::*[name()=name(current())])+1, ']')" />
					<!--
					<xsl:value-of select="concat('document($wpofile)//', name(), '[', count(preceding-sibling::*[name()=name(current())])+1, ']')" />
</xsl:variable>
					-->
					<xsl:value-of select="document($wpofile)//*[name() = $name and  count(preceding-sibling::*[name()=name(current())])+1 = $position]"/>
    </to>
  </TRANSLATE>
</xsl:template>

<xsl:template match="Dynfield[@label]">
<xsl:variable name="name" select="local-name()"/>
  <TRANSLATE>
    <from>
      <xsl:value-of select="@label"/>
    </from>
     <to>
      <xsl:value-of select="document($wpofile)//*[local-name() = $name]"/>
    </to>
</TRANSLATE>  
</xsl:template>

<xsl:template match="DynAttribut[@label]">
  <TRANSLATE>
    <from>
      <xsl:value-of select="@label"/>
    </from>
<to>
<xsl:variable name="name" select="local-name()"/>
      <xsl:value-of select="document($wpofile)//*[local-name() = $name]"/>
    </to>
  </TRANSLATE>  
</xsl:template>


<xsl:template match="ParamAction|Button">
<TRANSLATE>
<from>
<xsl:value-of select="@value"/>
</from>
<to>
<xsl:variable name="name" select="local-name()"/>
<xsl:value-of select="document($wpofile)//*[local-name() = $name]"/>
</to>
</TRANSLATE>  
 <xsl:apply-templates />
</xsl:template>

<xsl:template match="//Group">
	<TRANSLATE>
		<from>
		<xsl:value-of select="@label"/>
		</from>
		<to>
<xsl:variable name="name" select="local-name()"/>
<xsl:value-of select="document($wpofile)//*[local-name() = $name]"/>
		</to>

	</TRANSLATE>  
	<xsl:for-each select="Group">
		<TRANSLATE>
		<from>
		<xsl:value-of select="@label"/>
		</from>
		<to>
<xsl:variable name="name" select="local-name()"/>
<xsl:value-of select="document($wpofile)//*[local-name() = $name]"/>
		</to>
		</TRANSLATE>  
	</xsl:for-each>
</xsl:template>

<xsl:template match="text()"/>

</xsl:stylesheet>
