<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!-- specifique for Index translation -->
<!-- Translator is a stylesheet that accepts a .wpo translation file as parameter, and produces -->
<!-- a translated version of the file in input -->

<!-- example of use:  xsl-c -XSL translator.xsl -IN ../examples/dns.naat -PARAM wpofile "'tmp'" (prints on the stdout)-->

<xsl:param name="wpofile"/>

<xsl:output method="xml" encoding="iso-8859-1" indent="yes"/>

<xsl:template match="Index"> 
  <xsl:copy>
   <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>


<xsl:template match="node()|@*">
  <xsl:copy>
   <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>

<xsl:template match="//Group">
<xsl:copy>
   <xsl:apply-templates select="@*"/>
	<xsl:attribute name="label" >
  <xsl:call-template name="routine">
    <xsl:with-param name="fromtext">
      <xsl:value-of select="@label"/>
    </xsl:with-param>
  </xsl:call-template>
	</xsl:attribute>

	<xsl:for-each select="Group">
		<xsl:copy>
		   <xsl:apply-templates select="@*"/>
	<xsl:attribute name="label" >
		  <xsl:call-template name="routine">
		    <xsl:with-param name="fromtext">
		      <xsl:value-of select="@label"/>
		    </xsl:with-param>
		  </xsl:call-template>
	</xsl:attribute>
	<xsl:for-each select="Group">
		<xsl:copy>
		   <xsl:apply-templates select="@*"/>
	<xsl:attribute name="label" >
		  <xsl:call-template name="routine">
		    <xsl:with-param name="fromtext">
		      <xsl:value-of select="@label"/>
		    </xsl:with-param>
		  </xsl:call-template>
	</xsl:attribute>
		</xsl:copy>
	</xsl:for-each>
		</xsl:copy>


	</xsl:for-each>

</xsl:copy>

</xsl:template>

<!-- the actual translation routine -->
<xsl:template name="routine">
  <xsl:param name="fromtext"/>
  <xsl:choose>
<!-- if a translation exists for the given fromtext, insert the translation... -->
<!--(this test accesses the translation file twice: can we do better?) -->
    <xsl:when test="document($wpofile)//*/from[text()=$fromtext]/../to and string-length(document($wpofile)//*/from[text()=$fromtext]/../to)>0">
      <xsl:value-of select="document($wpofile)//*/from[text()=$fromtext]/../to"/>
    </xsl:when>
<!-- otherwise leave the english version -->
    <xsl:otherwise>
      <xsl:value-of select="$fromtext"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="text()">
  <xsl:value-of select="."/>
</xsl:template>
</xsl:stylesheet>
