<!DOCTYPE xsl:stylesheet [
<!ENTITY % imageEntity SYSTEM "../modules/dtd/image.ent">
%imageEntity;
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<!--
<xsl:output method="html" indent="yes" omit-xml-declaration="yes" encoding="iso-8859-1"/>
-->

<xsl:template name="generate_php_get_container">
	<xsl:param name="tableborders"/>
	<xsl:param name="fields"/>
	<xsl:text>
	</xsl:text>

	<xsl:comment>call generate_php_get_container()</xsl:comment>
	<!--
	<table>
		<xsl:attribute name="border">
			<xsl:value-of select="$tableborders"/>
		</xsl:attribute>

		-->
		<xsl:comment>for Input|Output|Button generate()</xsl:comment>
		<xsl:for-each select="*">
			<xsl:comment>position: <xsl:number level="any" value="position()"/></xsl:comment>
			<xsl:comment>value: <xsl:value-of select="local-name()"/></xsl:comment>
			<xsl:text>
			</xsl:text>
			<xsl:call-template name="generate_php_field">
				<xsl:with-param name="tableborders"/>
			</xsl:call-template>
		</xsl:for-each>
		<xsl:comment>end generate()</xsl:comment>

		<!--
	</table>
	-->

	<xsl:comment>end generate_php_get_container()</xsl:comment>
	<xsl:text>
	</xsl:text>
</xsl:template>

<xsl:template name="generate_php_field">
	<xsl:param name="tableborders"/>
	<xsl:comment>start generate_php_field()</xsl:comment>
		<xsl:for-each select="*">
			<xsl:comment>colonne: <xsl:number value="position()"/></xsl:comment>
		<xsl:comment>value: <xsl:value-of select="local-name()"/></xsl:comment>
		<!--
		<xsl:apply-templates/>
		-->
	</xsl:for-each>
	<xsl:comment>end generate_php_field()</xsl:comment>
</xsl:template>

<!-- generate_php_popen 

    This template generates the php code needed to 
    popen() an external application and display its 
    result line after line in the browser's page.
-->
<xsl:template name="generate_php_popen">

	<!-- xsl:param name="code"/>

	<xsl:processing-instruction name="php">
	unset ($code);

	$code='<xsl:value-of select="$code"/>';

	generate_php_popen($code);
	?</xsl:processing-instruction -->


	<xsl:param name="code"/>

	<xsl:processing-instruction name="php">

	unset ($code);
	$code='<xsl:value-of select="@code"/>';

<xsl:text disable-output-escaping="yes">

  $descriptor = popen ("$code","r");

  while (!feof ($descriptor)) {
    $read_again = true;
    $buffer_size = 4096;
    $full = "";
    
    while ( !feof ($descriptor) &amp;&amp; ($read_again) ) {
      $read_again = false;
      $line = fgets ($descriptor, $buffer_size);
      $full .= $line;
      if (strlen ($line) >= ($buffer_size - 1)) {
	if ( $line[($buffer_size - 2)] != '\n' ) {
	  $read_again = true;
	}
      }
    }
    print $full."&lt;BR&gt;";
    flush ();
  }

  pclose ($descriptor);

</xsl:text>

	?</xsl:processing-instruction>


</xsl:template>



<!-- generate_php_preload_variables

    This template generates the php code needed to 
    load all variables used in a page with a single 
    backend call.
-->
<xsl:template name="generate_php_preload_variables">

	<xsl:param name="variables_list"/>

	<xsl:processing-instruction name="php">
	unset ($variables_list);

	// Simple quotes to prevent php from evaluating variables in the string
	$variables_list='<xsl:value-of select="$variables_list"/>';

	generate_php_preload_variables($variables_list);
	?</xsl:processing-instruction>


</xsl:template>



<!-- generate_php_get_dyntable

     This stylesheets generates the right php code to create
     a table, in which each row displays a list for variables.
     Parameters are set in the xsl template for input/dyntable
-->

<xsl:template name="generate_php_get_dyntable">

<xsl:param name="tableborders"/>
<xsl:param name="action_name"/>
<xsl:param name="variable_name"/>
<xsl:param name="href_action"/>
<xsl:param name="fields_string"/>
<xsl:param name="attribut_string"/>
<xsl:param name="param_actions"/>
<xsl:param name="button_actions"/>

<xsl:comment>call generate_php_get_dyntable()</xsl:comment>
	<table>
		<xsl:attribute name="border">
			<xsl:value-of select="$tableborders"/>
		</xsl:attribute>
		<xsl:attribute name="class">data</xsl:attribute>

<xsl:processing-instruction name="php">
	unset ($action_name);
	unset ($variable_name);
	unset ($href_action);
	unset ($fields_string);
	unset ($attribut_string);

	$action_name=&quot;<xsl:value-of select="$action_name"/>&quot;;
	$href_action=&quot;<xsl:value-of select="$href_action"/>&quot;;

	// Simple quotes to prevent php from evaluating variables in the string
	$variable_name='<xsl:value-of select="$variable_name"/>';

	$fields_string=&quot;<xsl:value-of select="$fields_string"/>&quot;;
	
	$attribut_string=&quot;<xsl:value-of select="$attribut_string"/>&quot;;

	$param_actions=&quot;<xsl:value-of select="$param_actions"/>&quot;;

	$button_actions=&quot;<xsl:value-of select="$button_actions"/>&quot;;

	generate_php_get_dyntable($action_name,$variable_name,$href_action,$fields_string,$param_actions,$button_actions,$attribut_string);
?</xsl:processing-instruction>
     </table>
     <br/>

<xsl:comment>end generate_php_get_dyntable()</xsl:comment>
</xsl:template>


<!-- generate_php_option

     Create an option (a 'row') in Checkbox and Boolean widgets
-->

<xsl:template name="generate_php_option">

<xsl:param name="variable_name"/>
<xsl:param name="type"/>
<xsl:param name="value"/>
<xsl:param name="default"/>
<xsl:param name="label"/>

<xsl:processing-instruction name="php">

unset ($variable_name);
unset ($type);
unset ($value);
unset ($default);
unset ($label);

// Simple quotes to prevent php from evaluating variables in the string
$variable_name='<xsl:value-of select="$variable_name"/>';
$value='<xsl:value-of select="$value"/>';

$type=&quot;<xsl:value-of select="$type"/>&quot;;
$default=&quot;<xsl:value-of select="$default"/>&quot;;
$label=&quot;<xsl:value-of select="$label"/>&quot;;

generate_php_option ($variable_name,$type,$value,$default,$label);

?</xsl:processing-instruction>

</xsl:template>



<!-- generate_php_get_list 

     Generate a dynamic list from an action
     3 types:
     list, boolean, checkbox
-->
	
<xsl:template name="generate_php_get_list">

<xsl:param name="action_name"/>
<xsl:param name="variable_name"/>
<xsl:param name="type"/>
<xsl:param name="param_actions"/>

<xsl:processing-instruction name="php">

unset ($variable_name);
unset ($action_name);
unset ($input_type);
unset ($param_actions);

// Simple quotes to prevent php from evaluating variables in the string
$variable_name='<xsl:value-of select="$variable_name"/>';

$action_name=&quot;<xsl:value-of select="$action_name"/>&quot;;
$input_type=&quot;<xsl:value-of select="$type"/>&quot;;
$param_actions=&quot;<xsl:value-of select="$param_actions"/>&quot;;

generate_php_get_list($variable_name,$input_type,$action_name,$param_actions);

?</xsl:processing-instruction>

</xsl:template>




<!-- generate_php_select_name_attribute

    This template generates the php code needed to 
    evaluate the name attribute of a select tag  
    (for lists like combo boxes)
-->
<xsl:template name="generate_php_select_name_attribute">

	<xsl:param name="variable_name"/>

	<xsl:processing-instruction name="php">
	unset ($variable_name);

	// Simple quotes to prevent php from evaluating variables in the string
	$variable_name='<xsl:value-of select="$variable_name"/>';

	print "".dereference_compound_variablename($variable_name)."";
	?</xsl:processing-instruction>

</xsl:template>




<!-- generate_php_get_variable

     This stylesheets generates the right php code to get the value of the
     given variable from the backend 
     we use <xsl:processing-instruction> construction to build the 
     php tag 
     sample output	:	
     <?php unset ($AccessType); 
     exec("config-wrapper.pl trans -g  AccessType" , &$AccessType, &$var);
     print $AccessType[0];
     ?>
-->

<xsl:template name="generate_php_get_variable">

<xsl:param name="variable_name"/>
<xsl:param name="action_name"/>
<xsl:param name="type"/>
<xsl:param name="type_field"/>
<xsl:param name="value"/>
<xsl:param name="size"/>

<xsl:processing-instruction name="php">

unset ($variable_name);
unset ($action_name);
unset ($input_type);
unset ($field_type);
unset ($value);
unset ($size);

// Simple quotes to prevent php from evaluating variables in the string
$variable_name='<xsl:value-of select="$variable_name"/>';
$value='<xsl:value-of select="$value"/>';

$action_name=&quot;<xsl:value-of select="$action_name"/>&quot;;
$input_type=&quot;<xsl:value-of select="$type"/>&quot;;
$type_field=&quot;<xsl:value-of select="$type_field"/>&quot;;
$size=&quot;<xsl:value-of select="$size"/>&quot;;

generate_php_get_variable($variable_name,$input_type,$action_name,$type_field,$value,$size);

?</xsl:processing-instruction>

</xsl:template>



<!-- spaces

     Simple tempate to create four nbspaces. 
     Please, add a parameter ! 
-->
<xsl:template name="spaces">
	<xsl:text
	disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
</xsl:template>

<!-- Rules for the title into a page -->
<xsl:template match="//Title">
	<h2 class="title"><img src="&dot-green;" alt="." /><xsl:value-of select="."/></h2>
</xsl:template>


<!-- Other small templates
-->
<xsl:template name="Label">
	<xsl:value-of select="."/>
</xsl:template>

<xsl:template name="Navigation"/>


<!-- Rules for a Description tag -->
<xsl:template match="//Description">
	<p class="description"><xsl:value-of select="."/></p>
</xsl:template>

<!-- Rules for a Introduction tag -->
<xsl:template match="//Introduction">
	<p class="introduction"><xsl:value-of select="."/></p>
</xsl:template>

<!-- Rules for a Point tag -->
<xsl:template match="//Point">
	<ul>
		<li>
			<xsl:value-of select="."/>
		</li>
	</ul>
</xsl:template>
	
<xsl:template match="Separator">
	<p class="separator">
		<img src="&separator;" alt="------" title="------" width="555" height="2"/>
	</p>
</xsl:template>


<!-- Rules for a Exemple tag -->
<xsl:template match="//Eg">
	   <xsl:param name="content"/>

   <table class="example" bgcolor="#9999CC" width="70%">
	<xsl:attribute name="border">
		<xsl:value-of select="$tableborders"/>
	</xsl:attribute>
	<tr valign="top">
		<td>
			<xsl:attribute name="class">tabcont<xsl:value-of select="$content"/>
			</xsl:attribute>

   <pre><xsl:value-of select="."/></pre>
   </td></tr>
   </table>
</xsl:template>

<!-- Rules for a Decoration tag -->
<xsl:template match="//Decoration">
	<p class="decoration">
	<xsl:element name="img">
 		<xsl:attribute name="src">
     			<xsl:value-of select="./IMAGE/@url"/>
		</xsl:attribute>
	</xsl:element>
	</p>
</xsl:template>

<!-- Rules for HiddenInfo tag -->
<xsl:template match="//HiddenInfo">

	<xsl:call-template name="generate_php_option">
		<xsl:with-param name="type">Hidden</xsl:with-param>
		<xsl:with-param name="variable_name"><xsl:value-of select="@variable"/></xsl:with-param>
		<xsl:with-param name="value"><xsl:value-of select="@value"/></xsl:with-param>
	</xsl:call-template>

</xsl:template>

<!-- Rules for Link tag -->
<xsl:template match="//Link">
	<!--
	<xsl:text disable-output-escaping="yes">&lt;A class="link" onClick='window.open("</xsl:text>
		-->
	<A class="link">
		<xsl:attribute name="href"><xsl:value-of select="@url"/></xsl:attribute>
		<!--
		<xsl:value-of select="@url"/>
		<xsl:text disable-output-escaping="yes">","</xsl:text>
		<xsl:value-of select="."/>
		<xsl:text disable-output-escaping="yes">","</xsl:text>
		<xsl:text disable-output-escaping="yes">toolbar=no,menubar=no,scrollbars=yes,width=400,height=300,resizable=yes"); return false' </xsl:text>
		<xsl:text disable-output-escaping="yes">href="</xsl:text>
		<xsl:value-of select="@url"/>
		<xsl:text disable-output-escaping="yes">"&gt;</xsl:text>
		<xsl:value-of select="."/>
	 <xsl:text disable-output-escaping="yes">&lt;/A&gt;</xsl:text>
		-->
		<xsl:value-of select="."/>
	</A>
</xsl:template>


<!--   #############   LAYOUT Declarations ############ -->

<!-- Rule for a layout creation -->
<xsl:template match="Layout">
	<table> 
		<xsl:attribute name="border">
			<xsl:value-of select="$tableborders"/>
		</xsl:attribute>
		<xsl:apply-templates/>
	</table> 
</xsl:template> 

<xsl:template match="Row">
	<tr valign="top">
		<xsl:apply-templates/>
	</tr> 
</xsl:template> 

<xsl:template match="Col">
	<td valign="top">
		<xsl:apply-templates/>
	</td> 
</xsl:template> 

<!--   #############   LAYOUT Declarations ############ -->

<!-- Rule for center tag -->
<xsl:template match="Center">
	<p align="center"><center>
		<xsl:apply-templates/>
	</center></p>
</xsl:template>


<!-- Rules for a Dynamic Table -->
<xsl:template match="Dyntable">
	<!--
	<table>
		<xsl:attribute name="border">
			<xsl:value-of select="$tableborders"/>
		</xsl:attribute>

		-->
		<xsl:call-template name="generate_php_get_dyntable">

			<xsl:with-param name="tableborders">
				<xsl:value-of select="$tableborders"/>
			</xsl:with-param>

		<!-- 'action' and 'variable' are mutually exclusive -->
		<!-- It's used to retrieve the list to display      -->		
			<xsl:with-param name="action_name">
				<xsl:value-of select="@action"/>
			</xsl:with-param>

			<xsl:with-param name="variable_name">
				<xsl:value-of select="@variable"/>
			</xsl:with-param>

			<!-- ** Action when you click on the first column item -->
			<!-- ** (the one generated dynamically)                -->
			<xsl:with-param name="href_action">
				<xsl:choose>
					<xsl:when test="string-length(@cmd)>0">
						<xsl:text>A class=\"tabcont\" HREF=\"engine.php?file=</xsl:text><xsl:value-of select="$root-path"/>/<xsl:value-of select="$src"/>/<xsl:value-of select="$src"/>.wvm&amp;<xsl:value-of select="@cmd"/>=true</xsl:when>
					<xsl:otherwise>
						<xsl:text>false</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:with-param>

			<!-- ** Process each Dynfield child to   -->
			<!-- ** build the fields list (a string) -->
			<!-- Each field has a type (text|image)  -->
			<!-- Each field can have an action too   -->
<!-- (i.e. Label1,Field1name:type[:optional action],Label2,Field2name:type,...) -->
<!-- e.g. IP Address,IP,Ethernet Mask, Mask                           -->
			<xsl:with-param name="fields_string">
				<xsl:for-each select="Dynfield">
					<xsl:value-of select="@label"/>
					<xsl:text>,</xsl:text>
					<xsl:value-of select="text()"/>
					<xsl:text>:</xsl:text>
					<xsl:value-of select="@type"/>
					<xsl:if	test="string-length(@cmd)>0">
						<xsl:text>:</xsl:text>
						<xsl:value-of select="@cmd"/>
					</xsl:if>
					<xsl:if test="not(position()=last())">
						<xsl:text>,</xsl:text>
					</xsl:if> 					
				</xsl:for-each>
			</xsl:with-param>

			<!-- ** Process each DynAttribut child to   -->
			<!-- ** build the attribut list (a string) -->
			<!-- Each field has a type (text|image)  -->
<!-- (i.e. Label1,Field1name:type,Label2,Field2name:type,...) -->
<!-- e.g. Server Zone,server:text,Client Zone,client:text          -->
			<xsl:with-param name="attribut_string">
				<xsl:for-each select="DynAttribut">
					<xsl:value-of select="@label"/>
					<xsl:text>,</xsl:text>
					<xsl:value-of select="@attribut"/>
					<xsl:text>:</xsl:text>
					<xsl:value-of select="@type"/>
					<xsl:if test="not(position()=last())">
						<xsl:text>,</xsl:text>
					</xsl:if> 					
				</xsl:for-each>
			</xsl:with-param>
			
			<!-- Process each ParamAction child -->
			<!-- TODO: factorize this part for dyntable,
			checkbox and boolean -->
			<xsl:with-param name="param_actions">

				<!-- child nodes are ParamAction/ParamButton -->
				<xsl:apply-templates/>
				<!--

				<xsl:for-each select="ParamAction">

<xsl:text>A HREF=\"engine.php?file=</xsl:text>
<xsl:value-of select="$src"/>/<xsl:value-of select="$src"/>.wvm&amp;<xsl:value-of select="@cmd"/><xsl:text>=true</xsl:text>
<xsl:for-each select="//Page[@name=$page]/HiddenInfo">
<xsl:text>&amp;</xsl:text>
<xsl:value-of select="@variable"/>=<xsl:value-of select="@value"/>
<xsl:text></xsl:text>
</xsl:for-each>
<xsl:text> (value=</xsl:text><xsl:value-of select="@value"/>
					<xsl:choose>
						<xsl:when test="@type='image'">
						 <xsl:text> type=</xsl:text><xsl:value-of select="@type"/>
							<xsl:text> imgname=images/</xsl:text><xsl:value-of select="@imgname"/><xsl:text>.gif</xsl:text>
						</xsl:when>
					<xsl:otherwise>
						<xsl:text> type=</xsl:text><xsl:value-of select="@type"/>
					</xsl:otherwise>
				</xsl:choose>
				<!- old style
					<xsl:if test="string-length(@type)>0">
						<xsl:text> type=</xsl:text>
						<xsl:value-of select="@type"/>
					</xsl:if>
					-
					<xsl:text>)</xsl:text>

					<xsl:if test="not(position()=last())">
						<xsl:text>,</xsl:text>
					</xsl:if> 					
				</xsl:for-each>

				-->
			</xsl:with-param>

			<!-- Process each ParamButton child -->
			<!-- TODO: factorize this part for dyntable,
			checkbox and boolean -->
			<xsl:with-param name="button_actions">

				<xsl:for-each select="ParamButton">

<xsl:text>INPUT (</xsl:text>name=<xsl:value-of select="@cmd"/> value=<xsl:value-of select="@value"/>
					<xsl:choose>
						<xsl:when test="@type='image'">
						 <xsl:text> type=</xsl:text><xsl:value-of select="@type"/>
							<xsl:text> imgname=</xsl:text><xsl:call-template name="filename">
										<xsl:with-param name="x">
											<xsl:value-of select="unparsed-entity-uri(@imgname)"/>
										</xsl:with-param>
									</xsl:call-template>

						</xsl:when>
					<xsl:otherwise>
						<xsl:text> type=</xsl:text><xsl:value-of select="@type"/>
					</xsl:otherwise>
				</xsl:choose>
										<xsl:text>)</xsl:text>

					<xsl:if test="not(position()=last())">
						<xsl:text>,</xsl:text>
					</xsl:if> 					
				</xsl:for-each>

			</xsl:with-param>

		</xsl:call-template>
		<!--
     </table>
     <br/>
					-->
</xsl:template>

<!-- ************* Container, Inputs and Outputs ************* -->
<!-- ***** All Inputs/Outputs must be in a Container (needed for automatic alignment) ***** -->
<!-- Inputs  : will post variables and values                       -->
<!-- Outputs : won't post anything (uneditable fields for example ) --> 

<!-- Rules for a Container (used to align inputs, for instance) -->
<xsl:template match="Container">
	<table>
		<xsl:attribute name="border">
			<xsl:value-of select="$tableborders"/>
		</xsl:attribute>
		<xsl:attribute name="class">data</xsl:attribute>


	<xsl:call-template name="generate_php_get_container">
		<xsl:with-param name="tableborders">
			<xsl:value-of select="$tableborders"/>
		</xsl:with-param>
		<xsl:with-param name="fields"/>
	</xsl:call-template>

	<xsl:apply-templates mode="line" select="."/>

	<xsl:apply-templates/>
	</table>
	<br/>
</xsl:template>
				<!--
<xsl:template match="Container">
		<xsl:call-template name="generate_php_get_container">
			<xsl:with-param name="tableborders">
				<xsl:value-of select="$tableborders"/>
			</xsl:with-param>
			<xsl:with-param name="fields">
				<xsl:apply-templates/>
				<xsl:value-of select="Input|Output|Button"/>
			</xsl:with-param>
  <table>
	<xsl:attribute name="border">
		<xsl:value-of select="$tableborders"/>
	</xsl:attribute>
	<xsl:apply-templates/>
  </table>
	</xsl:call-template>
</xsl:template>

		-->

<!-- Rules for an action Button -->
<!-- To be used in conjunction with the function 'frontend_get_action' -->
<!-- 'name' must be of the form 'action1', 'action2', and so on ...   -->
<!--        frontend_get_action will return 1, or 2, ..., accordingly -->
<!-- *Must* be in a container (for automatic alignment purposes)     -->

<xsl:template match="Input|Output|Button" mode="line">
	<xsl:comment>line: <xsl:number level="any" value="position() div 2"/></xsl:comment>
	<xsl:apply-templates mode="col" select="."/>
</xsl:template>

<xsl:template match="Label|Field|List|Checkbox|Boolean" mode="col">
	<xsl:comment>Column : <xsl:number level="any" value="position() div 2"/></xsl:comment>
</xsl:template>


<xsl:template match="Button">
		<xsl:variable name="content" select="((position() div 2) mod 2)"/>
			<xsl:comment>start Button Table</xsl:comment>
	<xsl:apply-templates mode="col" select="."/>

	<xsl:comment>position: <xsl:value-of select="$content"/></xsl:comment>
			<!--
			<xsl:comment>line: <xsl:number level="any" from=".."/></xsl:comment>
	 	<xsl:comment>value: <xsl:value-of select="local-name()"/></xsl:comment>
			-->
	<tr>
		<td class="tabtitle">
			<b class="input">
				<xsl:value-of select="./Label/."/>
			</b>
		</td>
		<td valign="top">
			<xsl:attribute name="class">tabcont<xsl:value-of select="$content"/></xsl:attribute>


			<xsl:element name="input">
				<xsl:choose>
					<xsl:when test="@type='image'">
						<xsl:attribute name="type">image</xsl:attribute>

						<xsl:choose>
							<xsl:when test="string-length(@imgname)>0">
													<xsl:attribute name="src">
									<xsl:call-template name="filename">
										<xsl:with-param name="x">
											<xsl:value-of select="unparsed-entity-uri(@imgname)"/>
										</xsl:with-param>
									</xsl:call-template>
								</xsl:attribute>
							</xsl:when>
							<xsl:when test="string-length(@imgfile)>0">
								<xsl:attribute name="src"><xsl:value-of select="@imgfile"/></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="src">images/eye.gif</xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>										
						<xsl:attribute name="alt">[<xsl:value-of select="@value"/>]</xsl:attribute>
						<xsl:attribute name="title"><xsl:value-of select="@value"/></xsl:attribute>
						<xsl:attribute name="border">0</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="type">submit</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:attribute name="name"><xsl:value-of select="@cmd"/></xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
			</xsl:element>
		</td>
	</tr>
			<xsl:comment>end Button Table</xsl:comment>
</xsl:template>


<!-- Rule for an Input widget -->
<xsl:template match="Input">
		<xsl:variable name="content" select="((position() div 2) mod 2)"/>
			<xsl:comment>start Input Table</xsl:comment>
	<xsl:apply-templates mode="col" select="."/>
	<xsl:comment>position: <xsl:value-of select="$content"/></xsl:comment>
			<!--
			<xsl:comment>line: <xsl:number level="any" from=".."/></xsl:comment>
	 	<xsl:comment>value: <xsl:value-of select="local-name()"/></xsl:comment>
			-->
	<tr>
		<xsl:choose>
			<xsl:when test="./Label/@pos='top'">
				<td colspan="0" class="tabtitle">
					<b class="input">
						<xsl:value-of select="./Label/."/>
					</b>
			</td>
			</xsl:when>
			<xsl:otherwise>
				<td class="tabtitle">
					<b class="input">
						<xsl:value-of select="./Label/."/>
				</b>
			</td>
			</xsl:otherwise>
		</xsl:choose>

		<td valign="top">
<xsl:attribute name="class">tabcont<xsl:value-of select="$content"/>
			</xsl:attribute>
			<table>
				<xsl:attribute name="border">
					<xsl:value-of select="$tableborders"/>
				</xsl:attribute>
				<!-- Process static and dynamic options -->
				<xsl:apply-templates>
					<xsl:with-param name="content">
						<xsl:value-of select="$content"/>
					</xsl:with-param>
				</xsl:apply-templates>

			</table>
		</td>
	</tr>
			<xsl:comment>end Input Table</xsl:comment>
</xsl:template>

<!-- Rule for an Output widget -->
<xsl:template match="Output">
	<xsl:apply-templates mode="col" select="."/>
		<xsl:variable name="content" select="((position() div 2) mod 2)"/>
			<xsl:comment>start Output Table</xsl:comment>
			<xsl:comment>position: <xsl:value-of select="$content"/> </xsl:comment>
				<!--
				<xsl:number level="any" from=".." value="((position() div 2) mod 2)"/>
				-->
			<!--
			<xsl:comment>line: <xsl:number level="any" from=".."/></xsl:comment>
	 	<xsl:comment>value: <xsl:value-of select="local-name()"/></xsl:comment>
			-->
	<tr>

		<xsl:choose>
	<xsl:when test="./Label/@pos='top'">
				<td colspan="0" class="tabtitle">
					<b class="output">
						<xsl:value-of select="./Label/."/>
					</b>
			</td>
			</xsl:when>
			<xsl:otherwise>
				<td class="tabtitle"> 
					<b class="output">
						<xsl:value-of select="./Label/."/>
					</b>
				</td>
			</xsl:otherwise>
		</xsl:choose>

		<td valign="top">
			<xsl:attribute name="class">tabcont<xsl:value-of select="$content"/>
			</xsl:attribute>
			<table>
				<xsl:attribute name="border">
					<xsl:value-of select="$tableborders"/>
				</xsl:attribute>
				<!-- Process static and dynamic options -->
		<tr>
				<xsl:apply-templates>
					<xsl:with-param name="content">
							<xsl:value-of select="$content"/>
					</xsl:with-param>
				</xsl:apply-templates>
	</tr>
			</table>
		</td>
	</tr>
	<!-- xsl:call-template name="spaces"/> -->
<!-- </td></tr> -->
			<xsl:comment>end Output Table</xsl:comment>
			<xsl:text>
</xsl:text>
	</xsl:template>

<!-- For Field                                           --> 
<!-- output:<input type="text" size="20" maxlength="20"  -->
<!-- name="VARIABLE" value="<?php ?>">                   -->
<!-- To be cleaned when time !                           -->
  <xsl:template match="Field">
			<xsl:param name="content"/>
  <!-- xsl:call-template name="Label"/ -->
			<td>
				<xsl:attribute name="class">tabcont<xsl:value-of select="$content"/>
			</xsl:attribute>

				<xsl:call-template name="generate_php_get_variable">
					<xsl:with-param name="variable_name">
						<xsl:value-of select="./@variable"/>
					</xsl:with-param>
					<xsl:with-param name="action_name">
						<xsl:value-of select="./@action"/>
					</xsl:with-param>
					<xsl:with-param name="type">
						<xsl:value-of select="./@type"/>
					</xsl:with-param>
					<xsl:with-param name="type_field">
						<xsl:value-of select="name(parent::*)"/>
					</xsl:with-param>
					<xsl:with-param name="value">
						<xsl:value-of select="./."/>
					</xsl:with-param>
					<xsl:with-param name="size">
						<xsl:value-of select="./@size"/>
					</xsl:with-param>
				</xsl:call-template>
		</td>
  </xsl:template>

<!-- For File upload -->
  <xsl:template match="File">
			<xsl:param name="content"/>
				<td>
					<xsl:attribute name="class">tabcont<xsl:value-of select="$content"/>
					</xsl:attribute>


		<!-- xsl:element name="input">
			<xsl:attribute name="type">hidden</xsl:attribute>
			<xsl:attribute name="name">MAX_FILE_SIZE</xsl:attribute>
			<xsl:attribute name="value"><xsl:value-of select="@maxsize"/></xsl:attribute>
		</xsl:element -->
		<xsl:element name="input">
			<xsl:attribute name="type">file</xsl:attribute>
			<xsl:attribute name="name">UpdatedFile</xsl:attribute>
		</xsl:element>

		<!-- Post an optional 'uploaded filename' -->
		<xsl:if test="string-length(@uploadedfilename)>0">
		<xsl:element name="input">
			<xsl:attribute name="type">hidden</xsl:attribute>
			<xsl:attribute name="name">UploadedFilename</xsl:attribute>
			<xsl:attribute name="value"><xsl:value-of select="@uploadedfilename"/></xsl:attribute>
		</xsl:element>
		</xsl:if>
	</td>
  </xsl:template>

<!-- For static List : <select name="VARIABLE"> -->
<!-- For dynamic List : <select name="VARIABLE" action="shell-conf"> -->
  <xsl:template match="List">
			   <xsl:param name="content"/>
				<td>
					<xsl:attribute name="class">tabcont<xsl:value-of select="$content"/>
			</xsl:attribute>

  	<xsl:text disable-output-escaping="yes"><![CDATA[ <select name="]]></xsl:text>
		<!-- Use php to generate this attribute, so        -->
		<!-- that we can evaluate a compound variable like -->
		<!-- ${frontend_param1}BootProto                   -->
		<xsl:call-template name="generate_php_select_name_attribute">
			<xsl:with-param name="variable_name">
				<xsl:value-of select="./@variable"/>
			</xsl:with-param>
		</xsl:call-template>

		<xsl:text disable-output-escaping="yes">"</xsl:text>

		
		<xsl:if test="string-length(@size)>0">
			<xsl:text disable-output-escaping="yes"> size="</xsl:text>
				<xsl:value-of select="./@size"/>
			<xsl:text disable-output-escaping="yes">" </xsl:text>
		</xsl:if>
		
<xsl:if test="string-length(@type)>0">
				<xsl:value-of select="./@type"/>
		</xsl:if>

		<xsl:text disable-output-escaping="yes"><![CDATA[>]]></xsl:text>

		<!-- xsl:if test="string-length(@type)>0">
			<xsl:attribute name="type">
				<xsl:value-of select="./@type"/>
			</xsl:attribute>
		</xsl:if>

		<xsl:if test="string-length(@size)>0">
			<xsl:attribute name="size">
				<xsl:value-of select="./@size"/>	
			</xsl:attribute>
		</xsl:if -->

		<xsl:apply-templates select="Option" mode="List"/>

		<xsl:if test="string-length(@action)>0">
			<xsl:call-template name="generate_php_get_list">
				<xsl:with-param name="action_name">
					<xsl:value-of select="./@action"/>
				</xsl:with-param>
				<xsl:with-param name="variable_name">
					<xsl:value-of select="./@variable"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:if>

  	<xsl:text disable-output-escaping="yes"><![CDATA[ </select> ]]></xsl:text>
  </td>
  </xsl:template>

<!-- For Checkbox : 
choix 2<input type="checkbox" name="servers[]" value="DDDD-492835-SE"> -->

  <xsl:template match="Checkbox">

	 <!-- Process static options -->
	 <xsl:apply-templates select="Option" mode="Checkbox"/>

	 <!-- if it's a dynamic list -->
	 <xsl:if test="string-length(@action)>0">

		<xsl:call-template name="generate_php_get_list">

			<xsl:with-param name="action_name">
				<xsl:value-of select="./@action"/>
			</xsl:with-param>

			<xsl:with-param name="type">Checkbox</xsl:with-param>

			<xsl:with-param name="variable_name">
				<xsl:value-of select="./@variable"/>
			</xsl:with-param>

			<!-- ** Process each ParamAction child to -->
			<!-- ** build the actions list (a string) -->
<!-- builded_href_start_1 (type1=... value1=...), builded_href_start_2, ... -->
<!-- the href is incomplete to allow the php func to add parameters on each row -->
			<xsl:with-param name="param_actions">
				<!-- child nodes are ParamAction/ParamButton -->
				<xsl:apply-templates/>
				<!--

				<xsl:for-each select="ParamAction">

<xsl:text>A HREF=\"engine.php?file=</xsl:text>
<xsl:value-of select="$src"/>/<xsl:value-of select="$src"/>.wvm&amp;<xsl:value-of select="@cmd"/>=true (value=<xsl:value-of select="@value"/>
					<xsl:if test="string-length(@type)>0">
						<xsl:text> type=</xsl:text>
						<xsl:value-of select="@type"/>
					</xsl:if>
					<xsl:text>)</xsl:text>

					<xsl:if test="not(position()=last())">
						<xsl:text>,</xsl:text>
					</xsl:if> 					
				</xsl:for-each>

				-->
			</xsl:with-param>

		</xsl:call-template>

	</xsl:if>
  </xsl:template>

<!-- For Boolean : 
choix 1<input type="radio" name="servers" value="AAAA">
choix 2<input type="radio" name="servers" value="DDDD">
dynamic list through action="config-wrapperl trans -g LIST"
-->
  <xsl:template match="Boolean">

	 <!-- Process static options -->
	 <xsl:apply-templates select="Option" mode="Boolean"/>

	 <!-- if it's a dynamic list (action or variable has a content) -->
	 <xsl:if test="string-length(@action)>0">
		<xsl:call-template name="generate_php_get_list">

			<xsl:with-param name="action_name">
				<xsl:value-of select="./@action"/>
			</xsl:with-param>

			<xsl:with-param name="type">Boolean</xsl:with-param>

			<xsl:with-param name="variable_name">
				<xsl:value-of select="./@variable"/>
			</xsl:with-param>

			<!-- Process each ParamAction child  -->
			<xsl:with-param name="param_actions">
				<!-- child nodes are ParamAction/ParamButton -->
				<xsl:apply-templates/>
				<!--

				<xsl:for-each select="ParamAction">

<xsl:text>A HREF=\"engine.php?file=</xsl:text>
<xsl:value-of select="$src"/>/<xsl:value-of select="$src"/>.wvm&amp;<xsl:value-of select="@cmd"/>=true (value=<xsl:value-of select="@value"/>

					<xsl:if test="string-length(@type)>0">
						<xsl:text> type=</xsl:text>
						<xsl:value-of select="@type"/>
					</xsl:if>
					<xsl:text>)</xsl:text>

					<xsl:if test="not(position()=last())">
						<xsl:text>,</xsl:text>
					</xsl:if> 					
				</xsl:for-each>

				-->
			</xsl:with-param>


		</xsl:call-template>
	</xsl:if>
  </xsl:template>

<!-- For Option in List -->
<!-- output : <option value="VALUE">NAME</option> -->
  <xsl:template match="Option" mode="List">


	<xsl:call-template name="generate_php_option">
		<xsl:with-param name="type">List</xsl:with-param>
		<xsl:with-param name="variable_name">
			<xsl:value-of select="../@variable"/>
		</xsl:with-param>
		<xsl:with-param name="value"><xsl:value-of select="@value"/></xsl:with-param>
		<xsl:with-param name="default"><xsl:value-of select="@default"/></xsl:with-param>
		<xsl:with-param name="label"><xsl:value-of select="."/></xsl:with-param>
	</xsl:call-template>


<!-- old way
	<xsl:element name="option">
	<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
	<xsl:choose>
		<xsl:when test="@default='yes'">
			<xsl:attribute name="selected"/>
		</xsl:when>
	</xsl:choose>
	<xsl:value-of select="."/>
	</xsl:element>
-->
  </xsl:template>

<!-- For Option in Checkbox  -->
<!-- output : choix 2<input type="checkbox" name="variable[]" value="SE">  -->

  <xsl:template match="Option" mode="Checkbox">
<!-- ** Now use a php function to handle 'compound' variables -->
<!-- (variable_name="${frontend_param1}IP" for example)       -->

	<xsl:call-template name="generate_php_option">
		<xsl:with-param name="type">Checkbox</xsl:with-param>
		<xsl:with-param name="variable_name">
			<xsl:value-of select="../@variable"/>
		</xsl:with-param>
		<xsl:with-param name="value"><xsl:value-of select="@value"/></xsl:with-param>
		<xsl:with-param name="default"><xsl:value-of select="@default"/></xsl:with-param>
		<xsl:with-param name="label"><xsl:value-of select="."/></xsl:with-param>
	</xsl:call-template>

<!--
	<xsl:element name="input">
		<xsl:attribute name="type">checkbox</xsl:attribute>
		<xsl:attribute name="name"><xsl:value-of select="../@variable"/>[]</xsl:attribute>
		<xsl:attribute name="value"><xsl:value-of select="@value"/>
		</xsl:attribute>
	    <xsl:choose>
		<xsl:when test="@default='yes'">
			<xsl:attribute name="checked"/>
		</xsl:when>
		</xsl:choose>
	</xsl:element>
	<xsl:value-of select="."/>
-->

  </xsl:template>

<!-- For Option in Boolean -->
<!-- output : Yes ? <input type="radio" name="variable" value="SE">  -->

	<xsl:template match="Option" mode="Boolean">
		<xsl:call-template name="generate_php_option">
			<xsl:with-param name="type">Boolean</xsl:with-param>
			<xsl:with-param name="variable_name">
				<xsl:value-of select="../@variable"/>
			</xsl:with-param>
			<xsl:with-param name="value"><xsl:value-of select="@value"/></xsl:with-param>
			<xsl:with-param name="default"><xsl:value-of select="@default"/></xsl:with-param>
			<xsl:with-param name="label"><xsl:value-of select="."/></xsl:with-param>
		</xsl:call-template>
	<!--
	<xsl:element name="input">
		<xsl:attribute name="type">radio</xsl:attribute>
		<xsl:attribute name="name"><xsl:value-of select="../@variable"/></xsl:attribute>
		<xsl:attribute name="value"><xsl:value-of select="@value"/>
		</xsl:attribute>
	    <xsl:choose>
		<xsl:when test="@default='yes'">
			<xsl:attribute name="checked"/>
		</xsl:when>
		</xsl:choose>
	</xsl:element>
	<xsl:value-of select="."/>
	-->
  </xsl:template>


		<xsl:template match="Text">
			<xsl:value-of select="."/>
			<br/>
		</xsl:template>


<!--
ParamAction:
generate a one line HREF link with or without image with propagated Hidden info of the page
format:
param_actions="A HREF=\"engine.php?file=office_traffic/office_traffic.wvm&action2=true&frontend_param10=${frontend_param10}&frontend_param9=${frontend_param9}&frontend_param1=${frontend_param1} (value=Modify type=image imgname=images/edit.gif)"
-->
<xsl:template match="ParamAction">
	<!-- start building href -->
	<xsl:text>A class=\"tabcont\" HREF=\"engine.php?file=</xsl:text>
	<xsl:value-of select="$root-path"/>/<xsl:value-of select="$src"/>/<xsl:value-of select="$src"/>.wvm&amp;<xsl:value-of select="@cmd"/><xsl:text>=true</xsl:text>
	<!-- concat hidden info to propagate -->
	<xsl:for-each select="//Page[@name=$page]/HiddenInfo">
		<xsl:text>&amp;</xsl:text>
		<xsl:value-of select="@variable"/>=<xsl:value-of select="@value"/>
		<xsl:text></xsl:text>
	</xsl:for-each>
	<xsl:text> (value=</xsl:text><xsl:value-of select="@value"/>
	<xsl:choose>
		<xsl:when test="@type='image'">
		<!-- in case of image add gif -->
			<xsl:text> type=</xsl:text><xsl:value-of select="@type"/>
								
			<xsl:text> imgname=</xsl:text><xsl:call-template name="filename">
										<xsl:with-param name="x">
											<xsl:value-of select="unparsed-entity-uri(@imgname)"/>
										</xsl:with-param>
									</xsl:call-template>

			<!--
			<xsl:text> imgname=images/</xsl:text><xsl:value-of select="@imgname"/><xsl:text>.gif</xsl:text>
			-->
		</xsl:when>
		<xsl:otherwise>
			<xsl:text> type=</xsl:text><xsl:value-of select="@type"/>
		</xsl:otherwise>
	</xsl:choose>
	<xsl:text>)</xsl:text>

	<xsl:if test="not(position()=last())">
		<xsl:text>,</xsl:text>
	</xsl:if> 					
</xsl:template>



<!-- Structure for applets :
<object
        width="pixelWidth"
        height="pixelHeight"
      >
        <param name="code" value="yourClass.class">
        <param name="object" value="serializedObjectOrJavaBean">
        <param name="codebase" value="classFileDirectory">
         ...
        alternate-text
      </object>


<applet
        code="yourClass.class"
        object="serializedObjectOrJavaBean"
        codebase="classFileDirectory"
        width="pixelWidth"
        height="pixelHeight"
      >
        <param name="..." value="...">
         ...
        alternate-text
      </applet>

<embed
        code="yourClass.class"
        object="serializedObjectOrJavaBean"
        codebase="classFileDirectory"
        width="pixelWidth"
        height="pixelHeight"
      >
         ...
      </embed>
-->

<!-- Embedded Applications specific tags -->
<!-- Object, embed and applet tags are nested for maximum -->
<!-- compatibility with browsers (see just above) -->
<xsl:template match="EmbeddedApplication">

	<!-- xsl:if test="@type='applet'"-->
	<!-- object>
       		<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
       		<xsl:attribute name="height"><xsl:value-of select="@height"/></xsl:attribute>

		<param>
			<xsl:attribute name="name">archive</xsl:attribute>
			<xsl:attribute name="value"><xsl:value-of select="@name"/></xsl:attribute>
		</param>
		<param>
			<xsl:attribute name="name">codebase</xsl:attribute>
			<xsl:attribute name="value"><xsl:value-of select="$codebase"/></xsl:attribute>
		</param>
		<param> 
			<xsl:attribute name="name">code</xsl:attribute>
			<xsl:attribute name="value"><xsl:value-of select="@code"/>.class</xsl:attribute>
		</param -->

	<applet>
       		<xsl:attribute name="archive"><xsl:value-of select="@name"/>.jar</xsl:attribute>
       		<xsl:attribute name="codebase"><xsl:value-of select="$codebase"/></xsl:attribute>
       		<xsl:attribute name="code"><xsl:value-of select="@code"/>.class</xsl:attribute>
       		<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
       		<xsl:attribute name="height"><xsl:value-of select="@height"/></xsl:attribute>

	<!-- embed>
       		<xsl:attribute name="archive"><xsl:value-of select="@name"/>.jar</xsl:attribute>
       		<xsl:attribute name="codebase"><xsl:value-of select="$codebase"/></xsl:attribute>
       		<xsl:attribute name="code"><xsl:value-of select="@code"/>.class</xsl:attribute>
       		<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
       		<xsl:attribute name="height"><xsl:value-of select="@height"/></xsl:attribute -->

		<!-- Param elements to pass to the applet -->
		<xsl:apply-templates/>


	<!-- /embed -->

	</applet>

	<!-- /object -->

	<br/>
	<!-- /xsl:if -->

	<!-- xsl:if test="@type='system'">
		<xsl:call-template name="generate_php_popen">

	        <xsl:with-param name="code">
			<xsl:value-of select="@code"/>
		</xsl:with-param>

		</xsl:call-template>
	</xsl:if -->

</xsl:template>

<xsl:template match="EmbeddedApplication/Param">
	<param>
		<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
		<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
	</param>
</xsl:template>
<!-- End of Embedded Applications specific tags -->

<xsl:template match="IMAGE">
	<xsl:element name="img">
	 <xsl:attribute name="src">
		<xsl:value-of select="@url"/>
	 </xsl:attribute>
	</xsl:element>
</xsl:template>

</xsl:stylesheet>

<!-- $Id: php_func.xsl,v 1.16 2002/04/17 15:57:26 philippe Exp $ -->

