<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- produces a .wpo with the (empty) TRANSLATE tags for the tags that need translation -->
<!-- NOTE: It should try to make a merge if the translation file exists already -->

<!-- example of use: xsl-c -XSL prepare_translation.xsl -IN ../examples/dns.naat (prints on the standard output)-->

<xsl:output method="xml" encoding="iso-8859-1" indent="yes"/>

<xsl:template match="/">
<xsl:comment> $Id: prepare_translation.xsl,v 1.7 2002/09/10 08:23:57 philippe Exp $ </xsl:comment>
<![CDATA[
<!DOCTYPE Wizard SYSTEM "../../modules/dtd/Naat.dtd"[
<!ENTITY % definition SYSTEM "../../modules/dtd/definition.ent">
%definition;
]>
]]>

<TRANSLATIONS>
 <xsl:apply-templates/>
</TRANSLATIONS>
</xsl:template>

<xsl:template match="Introduction|Description|Title|Point|Option|Label">
  <TRANSLATE>
    <xsl:element name="from">
      <xsl:value-of select="."/>
    </xsl:element>
     <xsl:element name="to">
      <xsl:value-of select="."/>
    </xsl:element>
  </TRANSLATE>
</xsl:template>

<xsl:template match="Dynfield[@label]">
  <TRANSLATE>
    <xsl:element name="from">
      <xsl:value-of select="@label"/>
    </xsl:element>
     <xsl:element name="to">
      <xsl:value-of select="@label"/>
    </xsl:element>
</TRANSLATE>  
</xsl:template>

<xsl:template match="DynAttribut[@label]">
  <TRANSLATE>
    <xsl:element name="from">
      <xsl:value-of select="@label"/>
    </xsl:element>
<xsl:element name="to">
      <xsl:value-of select="@label"/>
    </xsl:element>
  </TRANSLATE>  
</xsl:template>


<xsl:template match="ParamAction|Button">
  <TRANSLATE>
    <xsl:element name="from">
      <xsl:value-of select="@value"/>
    </xsl:element>
<xsl:element name="to">
      <xsl:value-of select="@label"/>
    </xsl:element>
  </TRANSLATE>  
 <xsl:apply-templates />
</xsl:template>

<xsl:template match="//Group">
	<TRANSLATE>
		<xsl:element name="from">
		<xsl:value-of select="@label"/>
		</xsl:element>
		<xsl:element name="to"/>
	</TRANSLATE>  
	<xsl:for-each select="Group">
		<TRANSLATE>
		<xsl:element name="from">
		<xsl:value-of select="@label"/>
		</xsl:element>
		<xsl:element name="to"/>
		</TRANSLATE>  
<xsl:for-each select="Group">
		<TRANSLATE>
		<xsl:element name="from">
		<xsl:value-of select="@label"/>
		</xsl:element>
		<xsl:element name="to"/>
		</TRANSLATE>  
	</xsl:for-each>

	</xsl:for-each>
</xsl:template>

<xsl:template match="text()"/>

</xsl:stylesheet>
